var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../node_modules/stackframe/stackframe.js
var require_stackframe = __commonJS({
  "../../node_modules/stackframe/stackframe.js"(exports, module) {
    (function(root, factory) {
      "use strict";
      if (typeof define === "function" && define.amd) {
        define("stackframe", [], factory);
      } else if (typeof exports === "object") {
        module.exports = factory();
      } else {
        root.StackFrame = factory();
      }
    })(exports, function() {
      "use strict";
      function _isNumber(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
      }
      function _capitalize(str) {
        return str.charAt(0).toUpperCase() + str.substring(1);
      }
      function _getter(p) {
        return function() {
          return this[p];
        };
      }
      var booleanProps = ["isConstructor", "isEval", "isNative", "isToplevel"];
      var numericProps = ["columnNumber", "lineNumber"];
      var stringProps = ["fileName", "functionName", "source"];
      var arrayProps = ["args"];
      var objectProps = ["evalOrigin"];
      var props = booleanProps.concat(numericProps, stringProps, arrayProps, objectProps);
      function StackFrame(obj) {
        if (!obj)
          return;
        for (var i2 = 0; i2 < props.length; i2++) {
          if (obj[props[i2]] !== void 0) {
            this["set" + _capitalize(props[i2])](obj[props[i2]]);
          }
        }
      }
      StackFrame.prototype = {
        getArgs: function() {
          return this.args;
        },
        setArgs: function(v) {
          if (Object.prototype.toString.call(v) !== "[object Array]") {
            throw new TypeError("Args must be an Array");
          }
          this.args = v;
        },
        getEvalOrigin: function() {
          return this.evalOrigin;
        },
        setEvalOrigin: function(v) {
          if (v instanceof StackFrame) {
            this.evalOrigin = v;
          } else if (v instanceof Object) {
            this.evalOrigin = new StackFrame(v);
          } else {
            throw new TypeError("Eval Origin must be an Object or StackFrame");
          }
        },
        toString: function() {
          var fileName = this.getFileName() || "";
          var lineNumber = this.getLineNumber() || "";
          var columnNumber = this.getColumnNumber() || "";
          var functionName = this.getFunctionName() || "";
          if (this.getIsEval()) {
            if (fileName) {
              return "[eval] (" + fileName + ":" + lineNumber + ":" + columnNumber + ")";
            }
            return "[eval]:" + lineNumber + ":" + columnNumber;
          }
          if (functionName) {
            return functionName + " (" + fileName + ":" + lineNumber + ":" + columnNumber + ")";
          }
          return fileName + ":" + lineNumber + ":" + columnNumber;
        }
      };
      StackFrame.fromString = function StackFrame$$fromString(str) {
        var argsStartIndex = str.indexOf("(");
        var argsEndIndex = str.lastIndexOf(")");
        var functionName = str.substring(0, argsStartIndex);
        var args = str.substring(argsStartIndex + 1, argsEndIndex).split(",");
        var locationString = str.substring(argsEndIndex + 1);
        if (locationString.indexOf("@") === 0) {
          var parts = /@(.+?)(?::(\d+))?(?::(\d+))?$/.exec(locationString, "");
          var fileName = parts[1];
          var lineNumber = parts[2];
          var columnNumber = parts[3];
        }
        return new StackFrame({
          functionName,
          args: args || void 0,
          fileName,
          lineNumber: lineNumber || void 0,
          columnNumber: columnNumber || void 0
        });
      };
      for (var i = 0; i < booleanProps.length; i++) {
        StackFrame.prototype["get" + _capitalize(booleanProps[i])] = _getter(booleanProps[i]);
        StackFrame.prototype["set" + _capitalize(booleanProps[i])] = function(p) {
          return function(v) {
            this[p] = Boolean(v);
          };
        }(booleanProps[i]);
      }
      for (var j = 0; j < numericProps.length; j++) {
        StackFrame.prototype["get" + _capitalize(numericProps[j])] = _getter(numericProps[j]);
        StackFrame.prototype["set" + _capitalize(numericProps[j])] = function(p) {
          return function(v) {
            if (!_isNumber(v)) {
              throw new TypeError(p + " must be a Number");
            }
            this[p] = Number(v);
          };
        }(numericProps[j]);
      }
      for (var k = 0; k < stringProps.length; k++) {
        StackFrame.prototype["get" + _capitalize(stringProps[k])] = _getter(stringProps[k]);
        StackFrame.prototype["set" + _capitalize(stringProps[k])] = function(p) {
          return function(v) {
            this[p] = String(v);
          };
        }(stringProps[k]);
      }
      return StackFrame;
    });
  }
});

// ../../node_modules/error-stack-parser/error-stack-parser.js
var require_error_stack_parser = __commonJS({
  "../../node_modules/error-stack-parser/error-stack-parser.js"(exports, module) {
    (function(root, factory) {
      "use strict";
      if (typeof define === "function" && define.amd) {
        define("error-stack-parser", ["stackframe"], factory);
      } else if (typeof exports === "object") {
        module.exports = factory(require_stackframe());
      } else {
        root.ErrorStackParser = factory(root.StackFrame);
      }
    })(exports, function ErrorStackParser(StackFrame) {
      "use strict";
      var FIREFOX_SAFARI_STACK_REGEXP = /(^|@)\S+:\d+/;
      var CHROME_IE_STACK_REGEXP = /^\s*at .*(\S+:\d+|\(native\))/m;
      var SAFARI_NATIVE_CODE_REGEXP = /^(eval@)?(\[native code])?$/;
      return {
        /**
         * Given an Error object, extract the most information from it.
         *
         * @param {Error} error object
         * @return {Array} of StackFrames
         */
        parse: function ErrorStackParser$$parse(error) {
          if (typeof error.stacktrace !== "undefined" || typeof error["opera#sourceloc"] !== "undefined") {
            return this.parseOpera(error);
          } else if (error.stack && error.stack.match(CHROME_IE_STACK_REGEXP)) {
            return this.parseV8OrIE(error);
          } else if (error.stack) {
            return this.parseFFOrSafari(error);
          } else {
            throw new Error("Cannot parse given Error object");
          }
        },
        // Separate line and column numbers from a string of the form: (URI:Line:Column)
        extractLocation: function ErrorStackParser$$extractLocation(urlLike) {
          if (urlLike.indexOf(":") === -1) {
            return [urlLike];
          }
          var regExp = /(.+?)(?::(\d+))?(?::(\d+))?$/;
          var parts = regExp.exec(urlLike.replace(/[()]/g, ""));
          return [parts[1], parts[2] || void 0, parts[3] || void 0];
        },
        parseV8OrIE: function ErrorStackParser$$parseV8OrIE(error) {
          var filtered = error.stack.split("\n").filter(function(line) {
            return !!line.match(CHROME_IE_STACK_REGEXP);
          }, this);
          return filtered.map(function(line) {
            if (line.indexOf("(eval ") > -1) {
              line = line.replace(/eval code/g, "eval").replace(/(\(eval at [^()]*)|(\),.*$)/g, "");
            }
            var sanitizedLine = line.replace(/^\s+/, "").replace(/\(eval code/g, "(");
            var location2 = sanitizedLine.match(/ (\((.+):(\d+):(\d+)\)$)/);
            sanitizedLine = location2 ? sanitizedLine.replace(location2[0], "") : sanitizedLine;
            var tokens = sanitizedLine.split(/\s+/).slice(1);
            var locationParts = this.extractLocation(location2 ? location2[1] : tokens.pop());
            var functionName = tokens.join(" ") || void 0;
            var fileName = ["eval", "<anonymous>"].indexOf(locationParts[0]) > -1 ? void 0 : locationParts[0];
            return new StackFrame({
              functionName,
              fileName,
              lineNumber: locationParts[1],
              columnNumber: locationParts[2],
              source: line
            });
          }, this);
        },
        parseFFOrSafari: function ErrorStackParser$$parseFFOrSafari(error) {
          var filtered = error.stack.split("\n").filter(function(line) {
            return !line.match(SAFARI_NATIVE_CODE_REGEXP);
          }, this);
          return filtered.map(function(line) {
            if (line.indexOf(" > eval") > -1) {
              line = line.replace(/ line (\d+)(?: > eval line \d+)* > eval:\d+:\d+/g, ":$1");
            }
            if (line.indexOf("@") === -1 && line.indexOf(":") === -1) {
              return new StackFrame({
                functionName: line
              });
            } else {
              var functionNameRegex = /((.*".+"[^@]*)?[^@]*)(?:@)/;
              var matches = line.match(functionNameRegex);
              var functionName = matches && matches[1] ? matches[1] : void 0;
              var locationParts = this.extractLocation(line.replace(functionNameRegex, ""));
              return new StackFrame({
                functionName,
                fileName: locationParts[0],
                lineNumber: locationParts[1],
                columnNumber: locationParts[2],
                source: line
              });
            }
          }, this);
        },
        parseOpera: function ErrorStackParser$$parseOpera(e) {
          if (!e.stacktrace || e.message.indexOf("\n") > -1 && e.message.split("\n").length > e.stacktrace.split("\n").length) {
            return this.parseOpera9(e);
          } else if (!e.stack) {
            return this.parseOpera10(e);
          } else {
            return this.parseOpera11(e);
          }
        },
        parseOpera9: function ErrorStackParser$$parseOpera9(e) {
          var lineRE = /Line (\d+).*script (?:in )?(\S+)/i;
          var lines = e.message.split("\n");
          var result = [];
          for (var i = 2, len = lines.length; i < len; i += 2) {
            var match = lineRE.exec(lines[i]);
            if (match) {
              result.push(new StackFrame({
                fileName: match[2],
                lineNumber: match[1],
                source: lines[i]
              }));
            }
          }
          return result;
        },
        parseOpera10: function ErrorStackParser$$parseOpera10(e) {
          var lineRE = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i;
          var lines = e.stacktrace.split("\n");
          var result = [];
          for (var i = 0, len = lines.length; i < len; i += 2) {
            var match = lineRE.exec(lines[i]);
            if (match) {
              result.push(
                new StackFrame({
                  functionName: match[3] || void 0,
                  fileName: match[2],
                  lineNumber: match[1],
                  source: lines[i]
                })
              );
            }
          }
          return result;
        },
        // Opera 10.65+ Error.stack very similar to FF/Safari
        parseOpera11: function ErrorStackParser$$parseOpera11(error) {
          var filtered = error.stack.split("\n").filter(function(line) {
            return !!line.match(FIREFOX_SAFARI_STACK_REGEXP) && !line.match(/^Error created at/);
          }, this);
          return filtered.map(function(line) {
            var tokens = line.split("@");
            var locationParts = this.extractLocation(tokens.pop());
            var functionCall = tokens.shift() || "";
            var functionName = functionCall.replace(/<anonymous function(: (\w+))?>/, "$2").replace(/\([^)]*\)/g, "") || void 0;
            var argsRaw;
            if (functionCall.match(/\(([^)]*)\)/)) {
              argsRaw = functionCall.replace(/^[^(]+\(([^)]*)\)$/, "$1");
            }
            var args = argsRaw === void 0 || argsRaw === "[arguments not available]" ? void 0 : argsRaw.split(",");
            return new StackFrame({
              functionName,
              args,
              fileName: locationParts[0],
              lineNumber: locationParts[1],
              columnNumber: locationParts[2],
              source: line
            });
          }, this);
        }
      };
    });
  }
});

// ../../node_modules/stack-generator/stack-generator.js
var require_stack_generator = __commonJS({
  "../../node_modules/stack-generator/stack-generator.js"(exports, module) {
    (function(root, factory) {
      "use strict";
      if (typeof define === "function" && define.amd) {
        define("stack-generator", ["stackframe"], factory);
      } else if (typeof exports === "object") {
        module.exports = factory(require_stackframe());
      } else {
        root.StackGenerator = factory(root.StackFrame);
      }
    })(exports, function(StackFrame) {
      return {
        backtrace: function StackGenerator$$backtrace(opts) {
          var stack = [];
          var maxStackSize = 10;
          if (typeof opts === "object" && typeof opts.maxStackSize === "number") {
            maxStackSize = opts.maxStackSize;
          }
          var curr = arguments.callee;
          while (curr && stack.length < maxStackSize && curr["arguments"]) {
            var args = new Array(curr["arguments"].length);
            for (var i = 0; i < args.length; ++i) {
              args[i] = curr["arguments"][i];
            }
            if (/function(?:\s+([\w$]+))+\s*\(/.test(curr.toString())) {
              stack.push(new StackFrame({ functionName: RegExp.$1 || void 0, args }));
            } else {
              stack.push(new StackFrame({ args }));
            }
            try {
              curr = curr.caller;
            } catch (e) {
              break;
            }
          }
          return stack;
        }
      };
    });
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/util.js
var require_util = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/util.js"(exports) {
    function getArg(aArgs, aName, aDefaultValue) {
      if (aName in aArgs) {
        return aArgs[aName];
      } else if (arguments.length === 3) {
        return aDefaultValue;
      } else {
        throw new Error('"' + aName + '" is a required argument.');
      }
    }
    exports.getArg = getArg;
    var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;
    var dataUrlRegexp = /^data:.+\,.+$/;
    function urlParse(aUrl) {
      var match = aUrl.match(urlRegexp);
      if (!match) {
        return null;
      }
      return {
        scheme: match[1],
        auth: match[2],
        host: match[3],
        port: match[4],
        path: match[5]
      };
    }
    exports.urlParse = urlParse;
    function urlGenerate(aParsedUrl) {
      var url = "";
      if (aParsedUrl.scheme) {
        url += aParsedUrl.scheme + ":";
      }
      url += "//";
      if (aParsedUrl.auth) {
        url += aParsedUrl.auth + "@";
      }
      if (aParsedUrl.host) {
        url += aParsedUrl.host;
      }
      if (aParsedUrl.port) {
        url += ":" + aParsedUrl.port;
      }
      if (aParsedUrl.path) {
        url += aParsedUrl.path;
      }
      return url;
    }
    exports.urlGenerate = urlGenerate;
    function normalize(aPath) {
      var path = aPath;
      var url = urlParse(aPath);
      if (url) {
        if (!url.path) {
          return aPath;
        }
        path = url.path;
      }
      var isAbsolute = exports.isAbsolute(path);
      var parts = path.split(/\/+/);
      for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
        part = parts[i];
        if (part === ".") {
          parts.splice(i, 1);
        } else if (part === "..") {
          up++;
        } else if (up > 0) {
          if (part === "") {
            parts.splice(i + 1, up);
            up = 0;
          } else {
            parts.splice(i, 2);
            up--;
          }
        }
      }
      path = parts.join("/");
      if (path === "") {
        path = isAbsolute ? "/" : ".";
      }
      if (url) {
        url.path = path;
        return urlGenerate(url);
      }
      return path;
    }
    exports.normalize = normalize;
    function join(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      if (aPath === "") {
        aPath = ".";
      }
      var aPathUrl = urlParse(aPath);
      var aRootUrl = urlParse(aRoot);
      if (aRootUrl) {
        aRoot = aRootUrl.path || "/";
      }
      if (aPathUrl && !aPathUrl.scheme) {
        if (aRootUrl) {
          aPathUrl.scheme = aRootUrl.scheme;
        }
        return urlGenerate(aPathUrl);
      }
      if (aPathUrl || aPath.match(dataUrlRegexp)) {
        return aPath;
      }
      if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
        aRootUrl.host = aPath;
        return urlGenerate(aRootUrl);
      }
      var joined = aPath.charAt(0) === "/" ? aPath : normalize(aRoot.replace(/\/+$/, "") + "/" + aPath);
      if (aRootUrl) {
        aRootUrl.path = joined;
        return urlGenerate(aRootUrl);
      }
      return joined;
    }
    exports.join = join;
    exports.isAbsolute = function(aPath) {
      return aPath.charAt(0) === "/" || !!aPath.match(urlRegexp);
    };
    function relative(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      aRoot = aRoot.replace(/\/$/, "");
      var level = 0;
      while (aPath.indexOf(aRoot + "/") !== 0) {
        var index = aRoot.lastIndexOf("/");
        if (index < 0) {
          return aPath;
        }
        aRoot = aRoot.slice(0, index);
        if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
          return aPath;
        }
        ++level;
      }
      return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
    }
    exports.relative = relative;
    var supportsNullProto = function() {
      var obj = /* @__PURE__ */ Object.create(null);
      return !("__proto__" in obj);
    }();
    function identity(s) {
      return s;
    }
    function toSetString(aStr) {
      if (isProtoString(aStr)) {
        return "$" + aStr;
      }
      return aStr;
    }
    exports.toSetString = supportsNullProto ? identity : toSetString;
    function fromSetString(aStr) {
      if (isProtoString(aStr)) {
        return aStr.slice(1);
      }
      return aStr;
    }
    exports.fromSetString = supportsNullProto ? identity : fromSetString;
    function isProtoString(s) {
      if (!s) {
        return false;
      }
      var length = s.length;
      if (length < 9) {
        return false;
      }
      if (s.charCodeAt(length - 1) !== 95 || s.charCodeAt(length - 2) !== 95 || s.charCodeAt(length - 3) !== 111 || s.charCodeAt(length - 4) !== 116 || s.charCodeAt(length - 5) !== 111 || s.charCodeAt(length - 6) !== 114 || s.charCodeAt(length - 7) !== 112 || s.charCodeAt(length - 8) !== 95 || s.charCodeAt(length - 9) !== 95) {
        return false;
      }
      for (var i = length - 10; i >= 0; i--) {
        if (s.charCodeAt(i) !== 36) {
          return false;
        }
      }
      return true;
    }
    function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
      var cmp = mappingA.source - mappingB.source;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0 || onlyCompareOriginal) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      return mappingA.name - mappingB.name;
    }
    exports.compareByOriginalPositions = compareByOriginalPositions;
    function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0 || onlyCompareGenerated) {
        return cmp;
      }
      cmp = mappingA.source - mappingB.source;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return mappingA.name - mappingB.name;
    }
    exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;
    function strcmp(aStr1, aStr2) {
      if (aStr1 === aStr2) {
        return 0;
      }
      if (aStr1 > aStr2) {
        return 1;
      }
      return -1;
    }
    function compareByGeneratedPositionsInflated(mappingA, mappingB) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/binary-search.js
var require_binary_search = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/binary-search.js"(exports) {
    exports.GREATEST_LOWER_BOUND = 1;
    exports.LEAST_UPPER_BOUND = 2;
    function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
      var mid = Math.floor((aHigh - aLow) / 2) + aLow;
      var cmp = aCompare(aNeedle, aHaystack[mid], true);
      if (cmp === 0) {
        return mid;
      } else if (cmp > 0) {
        if (aHigh - mid > 1) {
          return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return aHigh < aHaystack.length ? aHigh : -1;
        } else {
          return mid;
        }
      } else {
        if (mid - aLow > 1) {
          return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return mid;
        } else {
          return aLow < 0 ? -1 : aLow;
        }
      }
    }
    exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
      if (aHaystack.length === 0) {
        return -1;
      }
      var index = recursiveSearch(
        -1,
        aHaystack.length,
        aNeedle,
        aHaystack,
        aCompare,
        aBias || exports.GREATEST_LOWER_BOUND
      );
      if (index < 0) {
        return -1;
      }
      while (index - 1 >= 0) {
        if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
          break;
        }
        --index;
      }
      return index;
    };
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/array-set.js
var require_array_set = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/array-set.js"(exports) {
    var util = require_util();
    var has = Object.prototype.hasOwnProperty;
    function ArraySet() {
      this._array = [];
      this._set = /* @__PURE__ */ Object.create(null);
    }
    ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
      var set = new ArraySet();
      for (var i = 0, len = aArray.length; i < len; i++) {
        set.add(aArray[i], aAllowDuplicates);
      }
      return set;
    };
    ArraySet.prototype.size = function ArraySet_size() {
      return Object.getOwnPropertyNames(this._set).length;
    };
    ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
      var sStr = util.toSetString(aStr);
      var isDuplicate = has.call(this._set, sStr);
      var idx = this._array.length;
      if (!isDuplicate || aAllowDuplicates) {
        this._array.push(aStr);
      }
      if (!isDuplicate) {
        this._set[sStr] = idx;
      }
    };
    ArraySet.prototype.has = function ArraySet_has(aStr) {
      var sStr = util.toSetString(aStr);
      return has.call(this._set, sStr);
    };
    ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
      var sStr = util.toSetString(aStr);
      if (has.call(this._set, sStr)) {
        return this._set[sStr];
      }
      throw new Error('"' + aStr + '" is not in the set.');
    };
    ArraySet.prototype.at = function ArraySet_at(aIdx) {
      if (aIdx >= 0 && aIdx < this._array.length) {
        return this._array[aIdx];
      }
      throw new Error("No element indexed by " + aIdx);
    };
    ArraySet.prototype.toArray = function ArraySet_toArray() {
      return this._array.slice();
    };
    exports.ArraySet = ArraySet;
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/base64.js
var require_base64 = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/base64.js"(exports) {
    var intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
    exports.encode = function(number) {
      if (0 <= number && number < intToCharMap.length) {
        return intToCharMap[number];
      }
      throw new TypeError("Must be between 0 and 63: " + number);
    };
    exports.decode = function(charCode) {
      var bigA = 65;
      var bigZ = 90;
      var littleA = 97;
      var littleZ = 122;
      var zero = 48;
      var nine = 57;
      var plus = 43;
      var slash = 47;
      var littleOffset = 26;
      var numberOffset = 52;
      if (bigA <= charCode && charCode <= bigZ) {
        return charCode - bigA;
      }
      if (littleA <= charCode && charCode <= littleZ) {
        return charCode - littleA + littleOffset;
      }
      if (zero <= charCode && charCode <= nine) {
        return charCode - zero + numberOffset;
      }
      if (charCode == plus) {
        return 62;
      }
      if (charCode == slash) {
        return 63;
      }
      return -1;
    };
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/base64-vlq.js
var require_base64_vlq = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/base64-vlq.js"(exports) {
    var base64 = require_base64();
    var VLQ_BASE_SHIFT = 5;
    var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
    var VLQ_BASE_MASK = VLQ_BASE - 1;
    var VLQ_CONTINUATION_BIT = VLQ_BASE;
    function toVLQSigned(aValue) {
      return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
    }
    function fromVLQSigned(aValue) {
      var isNegative = (aValue & 1) === 1;
      var shifted = aValue >> 1;
      return isNegative ? -shifted : shifted;
    }
    exports.encode = function base64VLQ_encode(aValue) {
      var encoded = "";
      var digit;
      var vlq = toVLQSigned(aValue);
      do {
        digit = vlq & VLQ_BASE_MASK;
        vlq >>>= VLQ_BASE_SHIFT;
        if (vlq > 0) {
          digit |= VLQ_CONTINUATION_BIT;
        }
        encoded += base64.encode(digit);
      } while (vlq > 0);
      return encoded;
    };
    exports.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
      var strLen = aStr.length;
      var result = 0;
      var shift = 0;
      var continuation, digit;
      do {
        if (aIndex >= strLen) {
          throw new Error("Expected more digits in base 64 VLQ value.");
        }
        digit = base64.decode(aStr.charCodeAt(aIndex++));
        if (digit === -1) {
          throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
        }
        continuation = !!(digit & VLQ_CONTINUATION_BIT);
        digit &= VLQ_BASE_MASK;
        result = result + (digit << shift);
        shift += VLQ_BASE_SHIFT;
      } while (continuation);
      aOutParam.value = fromVLQSigned(result);
      aOutParam.rest = aIndex;
    };
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/quick-sort.js
var require_quick_sort = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/quick-sort.js"(exports) {
    function swap(ary, x, y) {
      var temp = ary[x];
      ary[x] = ary[y];
      ary[y] = temp;
    }
    function randomIntInRange(low, high) {
      return Math.round(low + Math.random() * (high - low));
    }
    function doQuickSort(ary, comparator, p, r) {
      if (p < r) {
        var pivotIndex = randomIntInRange(p, r);
        var i = p - 1;
        swap(ary, pivotIndex, r);
        var pivot = ary[r];
        for (var j = p; j < r; j++) {
          if (comparator(ary[j], pivot) <= 0) {
            i += 1;
            swap(ary, i, j);
          }
        }
        swap(ary, i + 1, j);
        var q = i + 1;
        doQuickSort(ary, comparator, p, q - 1);
        doQuickSort(ary, comparator, q + 1, r);
      }
    }
    exports.quickSort = function(ary, comparator) {
      doQuickSort(ary, comparator, 0, ary.length - 1);
    };
  }
});

// ../../node_modules/stacktrace-gps/node_modules/source-map/lib/source-map-consumer.js
var require_source_map_consumer = __commonJS({
  "../../node_modules/stacktrace-gps/node_modules/source-map/lib/source-map-consumer.js"(exports) {
    var util = require_util();
    var binarySearch = require_binary_search();
    var ArraySet = require_array_set().ArraySet;
    var base64VLQ = require_base64_vlq();
    var quickSort = require_quick_sort().quickSort;
    function SourceMapConsumer(aSourceMap) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ""));
      }
      return sourceMap.sections != null ? new IndexedSourceMapConsumer(sourceMap) : new BasicSourceMapConsumer(sourceMap);
    }
    SourceMapConsumer.fromSourceMap = function(aSourceMap) {
      return BasicSourceMapConsumer.fromSourceMap(aSourceMap);
    };
    SourceMapConsumer.prototype._version = 3;
    SourceMapConsumer.prototype.__generatedMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_generatedMappings", {
      get: function() {
        if (!this.__generatedMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__generatedMappings;
      }
    });
    SourceMapConsumer.prototype.__originalMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_originalMappings", {
      get: function() {
        if (!this.__originalMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__originalMappings;
      }
    });
    SourceMapConsumer.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
      var c = aStr.charAt(index);
      return c === ";" || c === ",";
    };
    SourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      throw new Error("Subclasses must implement _parseMappings");
    };
    SourceMapConsumer.GENERATED_ORDER = 1;
    SourceMapConsumer.ORIGINAL_ORDER = 2;
    SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
    SourceMapConsumer.LEAST_UPPER_BOUND = 2;
    SourceMapConsumer.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
      var context = aContext || null;
      var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
      var mappings;
      switch (order) {
        case SourceMapConsumer.GENERATED_ORDER:
          mappings = this._generatedMappings;
          break;
        case SourceMapConsumer.ORIGINAL_ORDER:
          mappings = this._originalMappings;
          break;
        default:
          throw new Error("Unknown order of iteration.");
      }
      var sourceRoot = this.sourceRoot;
      mappings.map(function(mapping) {
        var source = mapping.source === null ? null : this._sources.at(mapping.source);
        if (source != null && sourceRoot != null) {
          source = util.join(sourceRoot, source);
        }
        return {
          source,
          generatedLine: mapping.generatedLine,
          generatedColumn: mapping.generatedColumn,
          originalLine: mapping.originalLine,
          originalColumn: mapping.originalColumn,
          name: mapping.name === null ? null : this._names.at(mapping.name)
        };
      }, this).forEach(aCallback, context);
    };
    SourceMapConsumer.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
      var line = util.getArg(aArgs, "line");
      var needle = {
        source: util.getArg(aArgs, "source"),
        originalLine: line,
        originalColumn: util.getArg(aArgs, "column", 0)
      };
      if (this.sourceRoot != null) {
        needle.source = util.relative(this.sourceRoot, needle.source);
      }
      if (!this._sources.has(needle.source)) {
        return [];
      }
      needle.source = this._sources.indexOf(needle.source);
      var mappings = [];
      var index = this._findMapping(
        needle,
        this._originalMappings,
        "originalLine",
        "originalColumn",
        util.compareByOriginalPositions,
        binarySearch.LEAST_UPPER_BOUND
      );
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (aArgs.column === void 0) {
          var originalLine = mapping.originalLine;
          while (mapping && mapping.originalLine === originalLine) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        } else {
          var originalColumn = mapping.originalColumn;
          while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        }
      }
      return mappings;
    };
    exports.SourceMapConsumer = SourceMapConsumer;
    function BasicSourceMapConsumer(aSourceMap) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ""));
      }
      var version = util.getArg(sourceMap, "version");
      var sources = util.getArg(sourceMap, "sources");
      var names = util.getArg(sourceMap, "names", []);
      var sourceRoot = util.getArg(sourceMap, "sourceRoot", null);
      var sourcesContent = util.getArg(sourceMap, "sourcesContent", null);
      var mappings = util.getArg(sourceMap, "mappings");
      var file = util.getArg(sourceMap, "file", null);
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      sources = sources.map(String).map(util.normalize).map(function(source) {
        return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source) ? util.relative(sourceRoot, source) : source;
      });
      this._names = ArraySet.fromArray(names.map(String), true);
      this._sources = ArraySet.fromArray(sources, true);
      this.sourceRoot = sourceRoot;
      this.sourcesContent = sourcesContent;
      this._mappings = mappings;
      this.file = file;
    }
    BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
    BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap) {
      var smc = Object.create(BasicSourceMapConsumer.prototype);
      var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
      var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
      smc.sourceRoot = aSourceMap._sourceRoot;
      smc.sourcesContent = aSourceMap._generateSourcesContent(
        smc._sources.toArray(),
        smc.sourceRoot
      );
      smc.file = aSourceMap._file;
      var generatedMappings = aSourceMap._mappings.toArray().slice();
      var destGeneratedMappings = smc.__generatedMappings = [];
      var destOriginalMappings = smc.__originalMappings = [];
      for (var i = 0, length = generatedMappings.length; i < length; i++) {
        var srcMapping = generatedMappings[i];
        var destMapping = new Mapping();
        destMapping.generatedLine = srcMapping.generatedLine;
        destMapping.generatedColumn = srcMapping.generatedColumn;
        if (srcMapping.source) {
          destMapping.source = sources.indexOf(srcMapping.source);
          destMapping.originalLine = srcMapping.originalLine;
          destMapping.originalColumn = srcMapping.originalColumn;
          if (srcMapping.name) {
            destMapping.name = names.indexOf(srcMapping.name);
          }
          destOriginalMappings.push(destMapping);
        }
        destGeneratedMappings.push(destMapping);
      }
      quickSort(smc.__originalMappings, util.compareByOriginalPositions);
      return smc;
    };
    BasicSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(BasicSourceMapConsumer.prototype, "sources", {
      get: function() {
        return this._sources.toArray().map(function(s) {
          return this.sourceRoot != null ? util.join(this.sourceRoot, s) : s;
        }, this);
      }
    });
    function Mapping() {
      this.generatedLine = 0;
      this.generatedColumn = 0;
      this.source = null;
      this.originalLine = null;
      this.originalColumn = null;
      this.name = null;
    }
    BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      var generatedLine = 1;
      var previousGeneratedColumn = 0;
      var previousOriginalLine = 0;
      var previousOriginalColumn = 0;
      var previousSource = 0;
      var previousName = 0;
      var length = aStr.length;
      var index = 0;
      var cachedSegments = {};
      var temp = {};
      var originalMappings = [];
      var generatedMappings = [];
      var mapping, str, segment, end, value;
      while (index < length) {
        if (aStr.charAt(index) === ";") {
          generatedLine++;
          index++;
          previousGeneratedColumn = 0;
        } else if (aStr.charAt(index) === ",") {
          index++;
        } else {
          mapping = new Mapping();
          mapping.generatedLine = generatedLine;
          for (end = index; end < length; end++) {
            if (this._charIsMappingSeparator(aStr, end)) {
              break;
            }
          }
          str = aStr.slice(index, end);
          segment = cachedSegments[str];
          if (segment) {
            index += str.length;
          } else {
            segment = [];
            while (index < end) {
              base64VLQ.decode(aStr, index, temp);
              value = temp.value;
              index = temp.rest;
              segment.push(value);
            }
            if (segment.length === 2) {
              throw new Error("Found a source, but no line and column");
            }
            if (segment.length === 3) {
              throw new Error("Found a source and line, but no column");
            }
            cachedSegments[str] = segment;
          }
          mapping.generatedColumn = previousGeneratedColumn + segment[0];
          previousGeneratedColumn = mapping.generatedColumn;
          if (segment.length > 1) {
            mapping.source = previousSource + segment[1];
            previousSource += segment[1];
            mapping.originalLine = previousOriginalLine + segment[2];
            previousOriginalLine = mapping.originalLine;
            mapping.originalLine += 1;
            mapping.originalColumn = previousOriginalColumn + segment[3];
            previousOriginalColumn = mapping.originalColumn;
            if (segment.length > 4) {
              mapping.name = previousName + segment[4];
              previousName += segment[4];
            }
          }
          generatedMappings.push(mapping);
          if (typeof mapping.originalLine === "number") {
            originalMappings.push(mapping);
          }
        }
      }
      quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
      this.__generatedMappings = generatedMappings;
      quickSort(originalMappings, util.compareByOriginalPositions);
      this.__originalMappings = originalMappings;
    };
    BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
      if (aNeedle[aLineName] <= 0) {
        throw new TypeError("Line must be greater than or equal to 1, got " + aNeedle[aLineName]);
      }
      if (aNeedle[aColumnName] < 0) {
        throw new TypeError("Column must be greater than or equal to 0, got " + aNeedle[aColumnName]);
      }
      return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    };
    BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
      for (var index = 0; index < this._generatedMappings.length; ++index) {
        var mapping = this._generatedMappings[index];
        if (index + 1 < this._generatedMappings.length) {
          var nextMapping = this._generatedMappings[index + 1];
          if (mapping.generatedLine === nextMapping.generatedLine) {
            mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
            continue;
          }
        }
        mapping.lastGeneratedColumn = Infinity;
      }
    };
    BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(
        needle,
        this._generatedMappings,
        "generatedLine",
        "generatedColumn",
        util.compareByGeneratedPositionsDeflated,
        util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND)
      );
      if (index >= 0) {
        var mapping = this._generatedMappings[index];
        if (mapping.generatedLine === needle.generatedLine) {
          var source = util.getArg(mapping, "source", null);
          if (source !== null) {
            source = this._sources.at(source);
            if (this.sourceRoot != null) {
              source = util.join(this.sourceRoot, source);
            }
          }
          var name = util.getArg(mapping, "name", null);
          if (name !== null) {
            name = this._names.at(name);
          }
          return {
            source,
            line: util.getArg(mapping, "originalLine", null),
            column: util.getArg(mapping, "originalColumn", null),
            name
          };
        }
      }
      return {
        source: null,
        line: null,
        column: null,
        name: null
      };
    };
    BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
      if (!this.sourcesContent) {
        return false;
      }
      return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function(sc) {
        return sc == null;
      });
    };
    BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      if (!this.sourcesContent) {
        return null;
      }
      if (this.sourceRoot != null) {
        aSource = util.relative(this.sourceRoot, aSource);
      }
      if (this._sources.has(aSource)) {
        return this.sourcesContent[this._sources.indexOf(aSource)];
      }
      var url;
      if (this.sourceRoot != null && (url = util.urlParse(this.sourceRoot))) {
        var fileUriAbsPath = aSource.replace(/^file:\/\//, "");
        if (url.scheme == "file" && this._sources.has(fileUriAbsPath)) {
          return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
        }
        if ((!url.path || url.path == "/") && this._sources.has("/" + aSource)) {
          return this.sourcesContent[this._sources.indexOf("/" + aSource)];
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
    BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
      var source = util.getArg(aArgs, "source");
      if (this.sourceRoot != null) {
        source = util.relative(this.sourceRoot, source);
      }
      if (!this._sources.has(source)) {
        return {
          line: null,
          column: null,
          lastColumn: null
        };
      }
      source = this._sources.indexOf(source);
      var needle = {
        source,
        originalLine: util.getArg(aArgs, "line"),
        originalColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(
        needle,
        this._originalMappings,
        "originalLine",
        "originalColumn",
        util.compareByOriginalPositions,
        util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND)
      );
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (mapping.source === needle.source) {
          return {
            line: util.getArg(mapping, "generatedLine", null),
            column: util.getArg(mapping, "generatedColumn", null),
            lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
          };
        }
      }
      return {
        line: null,
        column: null,
        lastColumn: null
      };
    };
    exports.BasicSourceMapConsumer = BasicSourceMapConsumer;
    function IndexedSourceMapConsumer(aSourceMap) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = JSON.parse(aSourceMap.replace(/^\)\]\}'/, ""));
      }
      var version = util.getArg(sourceMap, "version");
      var sections = util.getArg(sourceMap, "sections");
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      this._sources = new ArraySet();
      this._names = new ArraySet();
      var lastOffset = {
        line: -1,
        column: 0
      };
      this._sections = sections.map(function(s) {
        if (s.url) {
          throw new Error("Support for url field in sections not implemented.");
        }
        var offset = util.getArg(s, "offset");
        var offsetLine = util.getArg(offset, "line");
        var offsetColumn = util.getArg(offset, "column");
        if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
          throw new Error("Section offsets must be ordered and non-overlapping.");
        }
        lastOffset = offset;
        return {
          generatedOffset: {
            // The offset fields are 0-based, but we use 1-based indices when
            // encoding/decoding from VLQ.
            generatedLine: offsetLine + 1,
            generatedColumn: offsetColumn + 1
          },
          consumer: new SourceMapConsumer(util.getArg(s, "map"))
        };
      });
    }
    IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
    IndexedSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(IndexedSourceMapConsumer.prototype, "sources", {
      get: function() {
        var sources = [];
        for (var i = 0; i < this._sections.length; i++) {
          for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
            sources.push(this._sections[i].consumer.sources[j]);
          }
        }
        return sources;
      }
    });
    IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var sectionIndex = binarySearch.search(
        needle,
        this._sections,
        function(needle2, section2) {
          var cmp = needle2.generatedLine - section2.generatedOffset.generatedLine;
          if (cmp) {
            return cmp;
          }
          return needle2.generatedColumn - section2.generatedOffset.generatedColumn;
        }
      );
      var section = this._sections[sectionIndex];
      if (!section) {
        return {
          source: null,
          line: null,
          column: null,
          name: null
        };
      }
      return section.consumer.originalPositionFor({
        line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
        column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
        bias: aArgs.bias
      });
    };
    IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
      return this._sections.every(function(s) {
        return s.consumer.hasContentsOfAllSources();
      });
    };
    IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var content = section.consumer.sourceContentFor(aSource, true);
        if (content) {
          return content;
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
    IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        if (section.consumer.sources.indexOf(util.getArg(aArgs, "source")) === -1) {
          continue;
        }
        var generatedPosition = section.consumer.generatedPositionFor(aArgs);
        if (generatedPosition) {
          var ret = {
            line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
            column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
          };
          return ret;
        }
      }
      return {
        line: null,
        column: null
      };
    };
    IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      this.__generatedMappings = [];
      this.__originalMappings = [];
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var sectionMappings = section.consumer._generatedMappings;
        for (var j = 0; j < sectionMappings.length; j++) {
          var mapping = sectionMappings[j];
          var source = section.consumer._sources.at(mapping.source);
          if (section.consumer.sourceRoot !== null) {
            source = util.join(section.consumer.sourceRoot, source);
          }
          this._sources.add(source);
          source = this._sources.indexOf(source);
          var name = section.consumer._names.at(mapping.name);
          this._names.add(name);
          name = this._names.indexOf(name);
          var adjustedMapping = {
            source,
            generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
            generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name
          };
          this.__generatedMappings.push(adjustedMapping);
          if (typeof adjustedMapping.originalLine === "number") {
            this.__originalMappings.push(adjustedMapping);
          }
        }
      }
      quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
      quickSort(this.__originalMappings, util.compareByOriginalPositions);
    };
    exports.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
  }
});

// ../../node_modules/stacktrace-gps/stacktrace-gps.js
var require_stacktrace_gps = __commonJS({
  "../../node_modules/stacktrace-gps/stacktrace-gps.js"(exports, module) {
    (function(root, factory) {
      "use strict";
      if (typeof define === "function" && define.amd) {
        define("stacktrace-gps", ["source-map", "stackframe"], factory);
      } else if (typeof exports === "object") {
        module.exports = factory(require_source_map_consumer(), require_stackframe());
      } else {
        root.StackTraceGPS = factory(root.SourceMap || root.sourceMap, root.StackFrame);
      }
    })(exports, function(SourceMap, StackFrame) {
      "use strict";
      function _xdr(url) {
        return new Promise(function(resolve, reject) {
          var req = new XMLHttpRequest();
          req.open("get", url);
          req.onerror = reject;
          req.onreadystatechange = function onreadystatechange() {
            if (req.readyState === 4) {
              if (req.status >= 200 && req.status < 300 || url.substr(0, 7) === "file://" && req.responseText) {
                resolve(req.responseText);
              } else {
                reject(new Error("HTTP status: " + req.status + " retrieving " + url));
              }
            }
          };
          req.send();
        });
      }
      function _atob(b64str) {
        if (typeof window !== "undefined" && window.atob) {
          return window.atob(b64str);
        } else {
          throw new Error("You must supply a polyfill for window.atob in this environment");
        }
      }
      function _parseJson(string) {
        if (typeof JSON !== "undefined" && JSON.parse) {
          return JSON.parse(string);
        } else {
          throw new Error("You must supply a polyfill for JSON.parse in this environment");
        }
      }
      function _findFunctionName(source, lineNumber) {
        var syntaxes = [
          // {name} = function ({args}) TODO args capture
          /['"]?([$_A-Za-z][$_A-Za-z0-9]*)['"]?\s*[:=]\s*function\b/,
          // function {name}({args}) m[1]=name m[2]=args
          /function\s+([^('"`]*?)\s*\(([^)]*)\)/,
          // {name} = eval()
          /['"]?([$_A-Za-z][$_A-Za-z0-9]*)['"]?\s*[:=]\s*(?:eval|new Function)\b/,
          // fn_name() {
          /\b(?!(?:if|for|switch|while|with|catch)\b)(?:(?:static)\s+)?(\S+)\s*\(.*?\)\s*\{/,
          // {name} = () => {
          /['"]?([$_A-Za-z][$_A-Za-z0-9]*)['"]?\s*[:=]\s*\(.*?\)\s*=>/
        ];
        var lines = source.split("\n");
        var code = "";
        var maxLines = Math.min(lineNumber, 20);
        for (var i = 0; i < maxLines; ++i) {
          var line = lines[lineNumber - i - 1];
          var commentPos = line.indexOf("//");
          if (commentPos >= 0) {
            line = line.substr(0, commentPos);
          }
          if (line) {
            code = line + code;
            var len = syntaxes.length;
            for (var index = 0; index < len; index++) {
              var m = syntaxes[index].exec(code);
              if (m && m[1]) {
                return m[1];
              }
            }
          }
        }
        return void 0;
      }
      function _ensureSupportedEnvironment() {
        if (typeof Object.defineProperty !== "function" || typeof Object.create !== "function") {
          throw new Error("Unable to consume source maps in older browsers");
        }
      }
      function _ensureStackFrameIsLegit(stackframe) {
        if (typeof stackframe !== "object") {
          throw new TypeError("Given StackFrame is not an object");
        } else if (typeof stackframe.fileName !== "string") {
          throw new TypeError("Given file name is not a String");
        } else if (typeof stackframe.lineNumber !== "number" || stackframe.lineNumber % 1 !== 0 || stackframe.lineNumber < 1) {
          throw new TypeError("Given line number must be a positive integer");
        } else if (typeof stackframe.columnNumber !== "number" || stackframe.columnNumber % 1 !== 0 || stackframe.columnNumber < 0) {
          throw new TypeError("Given column number must be a non-negative integer");
        }
        return true;
      }
      function _findSourceMappingURL(source) {
        var sourceMappingUrlRegExp = /\/\/[#@] ?sourceMappingURL=([^\s'"]+)\s*$/mg;
        var lastSourceMappingUrl;
        var matchSourceMappingUrl;
        while (matchSourceMappingUrl = sourceMappingUrlRegExp.exec(source)) {
          lastSourceMappingUrl = matchSourceMappingUrl[1];
        }
        if (lastSourceMappingUrl) {
          return lastSourceMappingUrl;
        } else {
          throw new Error("sourceMappingURL not found");
        }
      }
      function _extractLocationInfoFromSourceMapSource(stackframe, sourceMapConsumer, sourceCache) {
        return new Promise(function(resolve, reject) {
          var loc = sourceMapConsumer.originalPositionFor({
            line: stackframe.lineNumber,
            column: stackframe.columnNumber
          });
          if (loc.source) {
            var mappedSource = sourceMapConsumer.sourceContentFor(loc.source);
            if (mappedSource) {
              sourceCache[loc.source] = mappedSource;
            }
            resolve(
              // given stackframe and source location, update stackframe
              new StackFrame({
                functionName: loc.name || stackframe.functionName,
                args: stackframe.args,
                fileName: loc.source,
                lineNumber: loc.line,
                columnNumber: loc.column
              })
            );
          } else {
            reject(new Error("Could not get original source for given stackframe and source map"));
          }
        });
      }
      return function StackTraceGPS(opts) {
        if (!(this instanceof StackTraceGPS)) {
          return new StackTraceGPS(opts);
        }
        opts = opts || {};
        this.sourceCache = opts.sourceCache || {};
        this.sourceMapConsumerCache = opts.sourceMapConsumerCache || {};
        this.ajax = opts.ajax || _xdr;
        this._atob = opts.atob || _atob;
        this._get = function _get(location2) {
          return new Promise(function(resolve, reject) {
            var isDataUrl = location2.substr(0, 5) === "data:";
            if (this.sourceCache[location2]) {
              resolve(this.sourceCache[location2]);
            } else if (opts.offline && !isDataUrl) {
              reject(new Error("Cannot make network requests in offline mode"));
            } else {
              if (isDataUrl) {
                var supportedEncodingRegexp = /^data:application\/json;([\w=:"-]+;)*base64,/;
                var match = location2.match(supportedEncodingRegexp);
                if (match) {
                  var sourceMapStart = match[0].length;
                  var encodedSource = location2.substr(sourceMapStart);
                  var source = this._atob(encodedSource);
                  this.sourceCache[location2] = source;
                  resolve(source);
                } else {
                  reject(new Error("The encoding of the inline sourcemap is not supported"));
                }
              } else {
                var xhrPromise = this.ajax(location2, { method: "get" });
                this.sourceCache[location2] = xhrPromise;
                xhrPromise.then(resolve, reject);
              }
            }
          }.bind(this));
        };
        this._getSourceMapConsumer = function _getSourceMapConsumer(sourceMappingURL, defaultSourceRoot) {
          return new Promise(function(resolve) {
            if (this.sourceMapConsumerCache[sourceMappingURL]) {
              resolve(this.sourceMapConsumerCache[sourceMappingURL]);
            } else {
              var sourceMapConsumerPromise = new Promise(function(resolve2, reject) {
                return this._get(sourceMappingURL).then(function(sourceMapSource) {
                  if (typeof sourceMapSource === "string") {
                    sourceMapSource = _parseJson(sourceMapSource.replace(/^\)\]\}'/, ""));
                  }
                  if (typeof sourceMapSource.sourceRoot === "undefined") {
                    sourceMapSource.sourceRoot = defaultSourceRoot;
                  }
                  resolve2(new SourceMap.SourceMapConsumer(sourceMapSource));
                }, reject);
              }.bind(this));
              this.sourceMapConsumerCache[sourceMappingURL] = sourceMapConsumerPromise;
              resolve(sourceMapConsumerPromise);
            }
          }.bind(this));
        };
        this.pinpoint = function StackTraceGPS$$pinpoint(stackframe) {
          return new Promise(function(resolve, reject) {
            this.getMappedLocation(stackframe).then(function(mappedStackFrame) {
              function resolveMappedStackFrame() {
                resolve(mappedStackFrame);
              }
              this.findFunctionName(mappedStackFrame).then(resolve, resolveMappedStackFrame)["catch"](resolveMappedStackFrame);
            }.bind(this), reject);
          }.bind(this));
        };
        this.findFunctionName = function StackTraceGPS$$findFunctionName(stackframe) {
          return new Promise(function(resolve, reject) {
            _ensureStackFrameIsLegit(stackframe);
            this._get(stackframe.fileName).then(function getSourceCallback(source) {
              var lineNumber = stackframe.lineNumber;
              var columnNumber = stackframe.columnNumber;
              var guessedFunctionName = _findFunctionName(source, lineNumber, columnNumber);
              if (guessedFunctionName) {
                resolve(new StackFrame({
                  functionName: guessedFunctionName,
                  args: stackframe.args,
                  fileName: stackframe.fileName,
                  lineNumber,
                  columnNumber
                }));
              } else {
                resolve(stackframe);
              }
            }, reject)["catch"](reject);
          }.bind(this));
        };
        this.getMappedLocation = function StackTraceGPS$$getMappedLocation(stackframe) {
          return new Promise(function(resolve, reject) {
            _ensureSupportedEnvironment();
            _ensureStackFrameIsLegit(stackframe);
            var sourceCache = this.sourceCache;
            var fileName = stackframe.fileName;
            this._get(fileName).then(function(source) {
              var sourceMappingURL = _findSourceMappingURL(source);
              var isDataUrl = sourceMappingURL.substr(0, 5) === "data:";
              var defaultSourceRoot = fileName.substring(0, fileName.lastIndexOf("/") + 1);
              if (sourceMappingURL[0] !== "/" && !isDataUrl && !/^https?:\/\/|^\/\//i.test(sourceMappingURL)) {
                sourceMappingURL = defaultSourceRoot + sourceMappingURL;
              }
              return this._getSourceMapConsumer(sourceMappingURL, defaultSourceRoot).then(function(sourceMapConsumer) {
                return _extractLocationInfoFromSourceMapSource(stackframe, sourceMapConsumer, sourceCache).then(resolve)["catch"](function() {
                  resolve(stackframe);
                });
              });
            }.bind(this), reject)["catch"](reject);
          }.bind(this));
        };
      };
    });
  }
});

// ../../node_modules/stacktrace-js/stacktrace.js
var require_stacktrace = __commonJS({
  "../../node_modules/stacktrace-js/stacktrace.js"(exports, module) {
    (function(root, factory) {
      "use strict";
      if (typeof define === "function" && define.amd) {
        define("stacktrace", ["error-stack-parser", "stack-generator", "stacktrace-gps"], factory);
      } else if (typeof exports === "object") {
        module.exports = factory(require_error_stack_parser(), require_stack_generator(), require_stacktrace_gps());
      } else {
        root.StackTrace = factory(root.ErrorStackParser, root.StackGenerator, root.StackTraceGPS);
      }
    })(exports, function StackTrace(ErrorStackParser, StackGenerator, StackTraceGPS) {
      var _options = {
        filter: function(stackframe) {
          return (stackframe.functionName || "").indexOf("StackTrace$$") === -1 && (stackframe.functionName || "").indexOf("ErrorStackParser$$") === -1 && (stackframe.functionName || "").indexOf("StackTraceGPS$$") === -1 && (stackframe.functionName || "").indexOf("StackGenerator$$") === -1;
        },
        sourceCache: {}
      };
      var _generateError = function StackTrace$$GenerateError() {
        try {
          throw new Error();
        } catch (err) {
          return err;
        }
      };
      function _merge(first, second) {
        var target = {};
        [first, second].forEach(function(obj) {
          for (var prop in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, prop)) {
              target[prop] = obj[prop];
            }
          }
          return target;
        });
        return target;
      }
      function _isShapedLikeParsableError(err) {
        return err.stack || err["opera#sourceloc"];
      }
      function _filtered(stackframes, filter) {
        if (typeof filter === "function") {
          return stackframes.filter(filter);
        }
        return stackframes;
      }
      return {
        /**
         * Get a backtrace from invocation point.
         *
         * @param {Object} opts
         * @returns {Array} of StackFrame
         */
        get: function StackTrace$$get(opts) {
          var err = _generateError();
          return _isShapedLikeParsableError(err) ? this.fromError(err, opts) : this.generateArtificially(opts);
        },
        /**
         * Get a backtrace from invocation point.
         * IMPORTANT: Does not handle source maps or guess function names!
         *
         * @param {Object} opts
         * @returns {Array} of StackFrame
         */
        getSync: function StackTrace$$getSync(opts) {
          opts = _merge(_options, opts);
          var err = _generateError();
          var stack = _isShapedLikeParsableError(err) ? ErrorStackParser.parse(err) : StackGenerator.backtrace(opts);
          return _filtered(stack, opts.filter);
        },
        /**
         * Given an error object, parse it.
         *
         * @param {Error} error object
         * @param {Object} opts
         * @returns {Promise} for Array[StackFrame}
         */
        fromError: function StackTrace$$fromError(error, opts) {
          opts = _merge(_options, opts);
          var gps = new StackTraceGPS(opts);
          return new Promise(function(resolve) {
            var stackframes = _filtered(ErrorStackParser.parse(error), opts.filter);
            resolve(Promise.all(stackframes.map(function(sf) {
              return new Promise(function(resolve2) {
                function resolveOriginal() {
                  resolve2(sf);
                }
                gps.pinpoint(sf).then(resolve2, resolveOriginal)["catch"](resolveOriginal);
              });
            })));
          }.bind(this));
        },
        /**
         * Use StackGenerator to generate a backtrace.
         *
         * @param {Object} opts
         * @returns {Promise} of Array[StackFrame]
         */
        generateArtificially: function StackTrace$$generateArtificially(opts) {
          opts = _merge(_options, opts);
          var stackFrames = StackGenerator.backtrace(opts);
          if (typeof opts.filter === "function") {
            stackFrames = stackFrames.filter(opts.filter);
          }
          return Promise.resolve(stackFrames);
        },
        /**
         * Given a function, wrap it such that invocations trigger a callback that
         * is called with a stack trace.
         *
         * @param {Function} fn to be instrumented
         * @param {Function} callback function to call with a stack trace on invocation
         * @param {Function} errback optional function to call with error if unable to get stack trace.
         * @param {Object} thisArg optional context object (e.g. window)
         */
        instrument: function StackTrace$$instrument(fn, callback, errback, thisArg) {
          if (typeof fn !== "function") {
            throw new Error("Cannot instrument non-function object");
          } else if (typeof fn.__stacktraceOriginalFn === "function") {
            return fn;
          }
          var instrumented = function StackTrace$$instrumented() {
            try {
              this.get().then(callback, errback)["catch"](errback);
              return fn.apply(thisArg || this, arguments);
            } catch (e) {
              if (_isShapedLikeParsableError(e)) {
                this.fromError(e).then(callback, errback)["catch"](errback);
              }
              throw e;
            }
          }.bind(this);
          instrumented.__stacktraceOriginalFn = fn;
          return instrumented;
        },
        /**
         * Given a function that has been instrumented,
         * revert the function to it's original (non-instrumented) state.
         *
         * @param {Function} fn to de-instrument
         */
        deinstrument: function StackTrace$$deinstrument(fn) {
          if (typeof fn !== "function") {
            throw new Error("Cannot de-instrument non-function object");
          } else if (typeof fn.__stacktraceOriginalFn === "function") {
            return fn.__stacktraceOriginalFn;
          } else {
            return fn;
          }
        },
        /**
         * Given an error message and Array of StackFrames, serialize and POST to given URL.
         *
         * @param {Array} stackframes
         * @param {String} url
         * @param {String} errorMsg
         * @param {Object} requestOptions
         */
        report: function StackTrace$$report(stackframes, url, errorMsg, requestOptions) {
          return new Promise(function(resolve, reject) {
            var req = new XMLHttpRequest();
            req.onerror = reject;
            req.onreadystatechange = function onreadystatechange() {
              if (req.readyState === 4) {
                if (req.status >= 200 && req.status < 400) {
                  resolve(req.responseText);
                } else {
                  reject(new Error("POST to " + url + " failed with status: " + req.status));
                }
              }
            };
            req.open("post", url);
            req.setRequestHeader("Content-Type", "application/json");
            if (requestOptions && typeof requestOptions.headers === "object") {
              var headers = requestOptions.headers;
              for (var header in headers) {
                if (Object.prototype.hasOwnProperty.call(headers, header)) {
                  req.setRequestHeader(header, headers[header]);
                }
              }
            }
            var reportPayload = { stack: stackframes };
            if (errorMsg !== void 0 && errorMsg !== null) {
              reportPayload.message = errorMsg;
            }
            req.send(JSON.stringify(reportPayload));
          });
        }
      };
    });
  }
});

// ../core/dist/lastReferenceIdManager/DefaultLastReferenceIdManager.js
var DefaultLastReferenceIdManager = class {
  constructor() {
    this._lastReferenceId = null;
  }
  /**
   * Gets the last event's reference id that was submitted to the server.
   */
  getLast() {
    return this._lastReferenceId;
  }
  /**
   * Clears the last event's reference id.
   */
  clearLast() {
    this._lastReferenceId = null;
  }
  /**
   * Sets the last event's reference id.
   */
  setLast(eventId) {
    this._lastReferenceId = eventId;
  }
};

// ../core/dist/logging/ConsoleLog.js
var ConsoleLog = class {
  trace(message) {
    this.log("debug", message);
  }
  info(message) {
    this.log("info", message);
  }
  warn(message) {
    this.log("warn", message);
  }
  error(message) {
    this.log("error", message);
  }
  log(level, message) {
    if (console) {
      const msg = `Exceptionless:${(/* @__PURE__ */ new Date()).toISOString()} [${level}] ${message}`;
      const logFn = console[level];
      if (logFn) {
        logFn(msg);
      } else if (console["log"]) {
        console["log"](msg);
      }
    }
  }
};

// ../core/dist/logging/NullLog.js
var NullLog = class {
  trace(_) {
  }
  info(_) {
  }
  warn(_) {
  }
  error(_) {
  }
};

// ../core/dist/models/Event.js
var KnownEventDataKeys;
(function(KnownEventDataKeys2) {
  KnownEventDataKeys2["Error"] = "@error";
  KnownEventDataKeys2["SimpleError"] = "@simple_error";
  KnownEventDataKeys2["RequestInfo"] = "@request";
  KnownEventDataKeys2["TraceLog"] = "@trace";
  KnownEventDataKeys2["EnvironmentInfo"] = "@environment";
  KnownEventDataKeys2["UserInfo"] = "@user";
  KnownEventDataKeys2["UserDescription"] = "@user_description";
  KnownEventDataKeys2["Version"] = "@version";
  KnownEventDataKeys2["Level"] = "@level";
  KnownEventDataKeys2["SubmissionMethod"] = "@submission_method";
  KnownEventDataKeys2["ManualStackingInfo"] = "@stack";
})(KnownEventDataKeys || (KnownEventDataKeys = {}));

// ../core/dist/Utils.js
function getHashCode(source) {
  if (!source || source.length === 0) {
    return 0;
  }
  let hash = 0;
  for (let index = 0; index < source.length; index++) {
    const character = source.charCodeAt(index);
    hash = (hash << 5) - hash + character;
    hash |= 0;
  }
  return hash;
}
function getCookies(cookies, exclusions) {
  const result = {};
  const parts = (cookies || "").split("; ");
  for (const part of parts) {
    const cookie = part.split("=");
    if (!isMatch(cookie[0], exclusions || [])) {
      result[cookie[0]] = cookie[1];
    }
  }
  return !isEmpty(result) ? result : null;
}
function guid() {
  function s4() {
    return Math.floor((1 + Math.random()) * 65536).toString(16).substring(1);
  }
  return s4() + s4() + "-" + s4() + "-" + s4() + "-" + s4() + "-" + s4() + s4() + s4();
}
function parseVersion(source) {
  if (!source) {
    return null;
  }
  const versionRegex = /(v?((\d+)\.(\d+)(\.(\d+))?)(?:-([\dA-Za-z-]+(?:\.[\dA-Za-z-]+)*))?(?:\+([\dA-Za-z-]+(?:\.[\dA-Za-z-]+)*))?)/;
  const matches = versionRegex.exec(source);
  if (matches && matches.length > 0) {
    return matches[0];
  }
  return null;
}
function parseQueryString(query, exclusions) {
  if (!query || query.length === 0) {
    return {};
  }
  const pairs = query.split("&");
  if (pairs.length === 0) {
    return {};
  }
  const result = {};
  for (const pair of pairs) {
    const parts = pair.split("=");
    if (!exclusions || !isMatch(parts[0], exclusions)) {
      result[decodeURIComponent(parts[0])] = decodeURIComponent(parts[1]);
    }
  }
  return !isEmpty(result) ? result : {};
}
function isMatch(input, patterns, ignoreCase = true) {
  if (typeof input !== "string") {
    return false;
  }
  const trim = /^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g;
  input = (ignoreCase ? input.toLowerCase() : input).replace(trim, "");
  return (patterns || []).some((pattern) => {
    if (typeof pattern !== "string") {
      return false;
    }
    if (pattern) {
      pattern = (ignoreCase ? pattern.toLowerCase() : pattern).replace(trim, "");
    }
    if (!pattern) {
      return input === void 0 || input === null;
    }
    if (pattern === "*") {
      return true;
    }
    if (input === void 0 || input === null) {
      return false;
    }
    const startsWithWildcard = pattern[0] === "*";
    if (startsWithWildcard) {
      pattern = pattern.slice(1);
    }
    const endsWithWildcard = pattern[pattern.length - 1] === "*";
    if (endsWithWildcard) {
      pattern = pattern.substring(0, pattern.length - 1);
    }
    if (startsWithWildcard && endsWithWildcard) {
      return pattern.length <= input.length && input.indexOf(pattern, 0) !== -1;
    }
    if (startsWithWildcard) {
      return endsWith(input, pattern);
    }
    if (endsWithWildcard) {
      return startsWith(input, pattern);
    }
    return input === pattern;
  });
}
function isEmpty(input) {
  if (input === null || input === void 0) {
    return true;
  }
  if (typeof input === "object") {
    if (Array.isArray(input)) {
      return input.length === 0;
    }
    if (input instanceof Date) {
      return false;
    }
    return Object.getOwnPropertyNames(input).length === 0;
  }
  if (typeof input === "string") {
    const trimmedInput = input.trim();
    return trimmedInput.length === 0 || trimmedInput === "{}" || trimmedInput === "[]";
  }
  return false;
}
function startsWith(input, prefix) {
  return input.substring(0, prefix.length) === prefix;
}
function endsWith(input, suffix) {
  return input.indexOf(suffix, input.length - suffix.length) !== -1;
}
function prune(value, depth = 10) {
  function isUnsupportedType(value2) {
    if (value2 === null || value2 === void 0) {
      return false;
    }
    switch (typeof value2) {
      case "function":
        return true;
      case "object":
        switch (Object.prototype.toString.call(value2)) {
          case "[object AsyncGenerator]":
          case "[object Generator]":
          case "[object ArrayBuffer]":
          case "[object Buffer]":
          case "[object DataView]":
          case "[object Promise]":
          case "[object WeakMap]":
          case "[object WeakSet]":
            return true;
        }
        if ("writeBigInt64LE" in value2) {
          return true;
        }
        break;
    }
    return false;
  }
  function normalizeValue(value2) {
    function hasToJSONFunction(value3) {
      return value3 !== null && typeof value3 === "object" && typeof value3.toJSON === "function";
    }
    if (typeof value2 === "bigint") {
      return `${value2.toString()}n`;
    }
    if (typeof value2 === "object") {
      if (Array.isArray(value2)) {
        return value2;
      }
      if (value2 instanceof Date) {
        return value2;
      }
      if (value2 instanceof Map) {
        const result = {};
        for (const [key, val] of value2) {
          result[key] = val;
        }
        return result;
      }
      if (value2 instanceof RegExp) {
        return value2.toString();
      }
      if (value2 instanceof Set) {
        return Array.from(value2);
      }
      const TypedArray = Object.getPrototypeOf(Uint8Array);
      if (value2 instanceof TypedArray) {
        return Array.from(value2);
      }
      if (hasToJSONFunction(value2)) {
        return normalizeValue(value2.toJSON());
      }
      return value2;
    }
    if (typeof value2 === "symbol") {
      return value2.description;
    }
    return value2;
  }
  function pruneImpl(value2, maxDepth, currentDepth = 10, seen = /* @__PURE__ */ new WeakSet(), parentIsArray = false) {
    if (value2 === null || value2 === void 0) {
      return value2;
    }
    if (currentDepth > maxDepth) {
      return void 0;
    }
    if (isUnsupportedType(value2)) {
      return void 0;
    }
    const normalizedValue = normalizeValue(value2);
    if (typeof normalizedValue === "object") {
      if (currentDepth == maxDepth) {
        return void 0;
      }
      if (Array.isArray(normalizedValue)) {
        const depth2 = parentIsArray ? currentDepth + 1 : currentDepth;
        return normalizedValue.map((e) => pruneImpl(e, maxDepth, depth2, seen, true));
      }
      if (normalizedValue instanceof Date) {
        return normalizedValue;
      }
      if (Object.prototype.toString.call(normalizedValue) === "[object Object]") {
        if (seen.has(normalizedValue)) {
          return void 0;
        }
        seen.add(normalizedValue);
      }
      const keys = /* @__PURE__ */ new Set([...Object.getOwnPropertyNames(normalizedValue), ...Object.getOwnPropertySymbols(normalizedValue)]);
      for (const key in normalizedValue) {
        keys.add(key);
      }
      const result = {};
      for (const key of keys) {
        const normalizedKey = normalizeValue(key);
        const objectValue = normalizedValue[key];
        result[normalizedKey] = pruneImpl(objectValue, maxDepth, currentDepth + 1, seen);
      }
      return result;
    }
    return normalizedValue;
  }
  if (depth < 0) {
    return void 0;
  }
  return pruneImpl(value, depth, 0);
}
function stringify(data, exclusions, maxDepth = 10) {
  function stringifyImpl(obj, excludedKeys) {
    return JSON.stringify(obj, (key, value) => {
      if (isMatch(key, excludedKeys)) {
        return;
      }
      return value;
    });
  }
  if (data === void 0) {
    return data;
  }
  const prunedData = prune(data, maxDepth);
  return stringifyImpl(prunedData, exclusions || []);
}
function toBoolean(input, defaultValue = false) {
  if (typeof input === "boolean") {
    return input;
  }
  if (input === null || typeof input !== "number" && typeof input !== "string") {
    return defaultValue;
  }
  switch ((input + "").toLowerCase().trim()) {
    case "true":
    case "yes":
    case "1":
      return true;
    case "false":
    case "no":
    case "0":
    case null:
      return false;
  }
  return defaultValue;
}
function toError(errorOrMessage, defaultMessage = "Unknown Error") {
  if (errorOrMessage === null || errorOrMessage === void 0) {
    const error2 = new Error(defaultMessage);
    error2.stack = void 0;
    return error2;
  }
  if (errorOrMessage instanceof Error) {
    return errorOrMessage;
  }
  if (typeof errorOrMessage === "string") {
    const error2 = new Error(errorOrMessage);
    error2.stack = void 0;
    return error2;
  }
  const error = new Error(stringify(errorOrMessage) || defaultMessage);
  error.stack = void 0;
  return error;
}
function allowProcessToExitWithoutWaitingForTimerOrInterval(timeoutOrIntervalId) {
  if (typeof timeoutOrIntervalId === "object" && "unref" in timeoutOrIntervalId) {
    timeoutOrIntervalId.unref();
  }
}

// ../core/dist/plugins/default/HeartbeatPlugin.js
var HeartbeatPlugin = class {
  constructor(heartbeatInterval = 6e4) {
    this.priority = 100;
    this.name = "HeartbeatPlugin";
    this._interval = heartbeatInterval >= 3e4 ? heartbeatInterval : 6e4;
  }
  startup() {
    clearInterval(this._intervalId);
    this._intervalId = void 0;
    return Promise.resolve();
  }
  suspend() {
    clearInterval(this._intervalId);
    this._intervalId = void 0;
    return Promise.resolve();
  }
  run(context) {
    if (this._interval <= 0) {
      return Promise.resolve();
    }
    clearInterval(this._intervalId);
    this._intervalId = void 0;
    const { config } = context.client;
    if (!config.currentSessionIdentifier) {
      const user = context.event.data?.[KnownEventDataKeys.UserInfo];
      if (!user?.identity) {
        return Promise.resolve();
      }
      config.currentSessionIdentifier = user.identity;
    }
    if (config.currentSessionIdentifier) {
      this._intervalId = setInterval(() => void context.client.submitSessionHeartbeat(config.currentSessionIdentifier), this._interval);
      allowProcessToExitWithoutWaitingForTimerOrInterval(this._intervalId);
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/default/SessionIdManagementPlugin.js
var SessionIdManagementPlugin = class {
  constructor() {
    this.priority = 25;
    this.name = "SessionIdManagementPlugin";
  }
  run(context) {
    const ev = context.event;
    const isSessionStart = ev.type === "session";
    const { config } = context.client;
    if (isSessionStart || !config.currentSessionIdentifier) {
      config.currentSessionIdentifier = guid().replaceAll("-", "");
    }
    if (isSessionStart) {
      ev.reference_id = config.currentSessionIdentifier;
    } else {
      if (!ev.data) {
        ev.data = {};
      }
      ev.data["@ref:session"] = config.currentSessionIdentifier;
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/default/ConfigurationDefaultsPlugin.js
var ConfigurationDefaultsPlugin = class {
  constructor() {
    this.priority = 10;
    this.name = "ConfigurationDefaultsPlugin";
  }
  run(context) {
    const { dataExclusions, defaultData, defaultTags } = context.client.config;
    const ev = context.event;
    if (defaultTags) {
      ev.tags = [...ev.tags || [], ...defaultTags];
    }
    if (defaultData) {
      if (!ev.data) {
        ev.data = {};
      }
      for (const key in defaultData) {
        if (ev.data[key] !== void 0 || isEmpty(defaultData[key])) {
          continue;
        }
        const data = stringify(defaultData[key], dataExclusions);
        if (!isEmpty(data)) {
          ev.data[key] = JSON.parse(data);
        }
      }
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/default/DuplicateCheckerPlugin.js
var DuplicateCheckerPlugin = class {
  constructor(getCurrentTime = () => Date.now(), interval = 3e4) {
    this.priority = 1010;
    this.name = "DuplicateCheckerPlugin";
    this._mergedEvents = [];
    this._processedHashCodes = [];
    this._getCurrentTime = getCurrentTime;
    this._interval = interval;
  }
  startup() {
    clearInterval(this._intervalId);
    this._intervalId = setInterval(() => void this.submitEvents(), this._interval);
    allowProcessToExitWithoutWaitingForTimerOrInterval(this._intervalId);
    return Promise.resolve();
  }
  async suspend() {
    clearInterval(this._intervalId);
    this._intervalId = void 0;
    await this.submitEvents();
  }
  run(context) {
    function calculateHashCode(error2) {
      let hash = 0;
      while (error2) {
        if (error2.message && error2.message.length) {
          hash += hash * 397 ^ getHashCode(error2.message);
        }
        if (error2.stack_trace && error2.stack_trace.length) {
          hash += hash * 397 ^ getHashCode(JSON.stringify(error2.stack_trace));
        }
        error2 = error2.inner;
      }
      return hash;
    }
    const error = context.event.data?.[KnownEventDataKeys.Error];
    const hashCode = calculateHashCode(error);
    if (hashCode) {
      const count = context.event.count || 1;
      const now = this._getCurrentTime();
      const merged = this._mergedEvents.filter((s) => s.hashCode === hashCode)[0];
      if (merged) {
        merged.incrementCount(count);
        merged.updateDate(context.event.date);
        context.log.info("Ignoring duplicate event with hash: " + hashCode);
        context.cancelled = true;
      }
      if (!context.cancelled && this._processedHashCodes.some((h) => h.hash === hashCode && h.timestamp >= now - this._interval)) {
        context.log.trace("Adding event with hash: " + hashCode);
        this._mergedEvents.push(new MergedEvent(hashCode, context, count));
        context.cancelled = true;
      }
      if (!context.cancelled) {
        context.log.trace(`Enqueueing event with hash: ${hashCode} to cache`);
        this._processedHashCodes.push({ hash: hashCode, timestamp: now });
        while (this._processedHashCodes.length > 50) {
          this._processedHashCodes.shift();
        }
      }
    }
    return Promise.resolve();
  }
  async submitEvents() {
    while (this._mergedEvents.length > 0) {
      await this._mergedEvents.shift()?.resubmit();
    }
  }
};
var MergedEvent = class {
  constructor(hashCode, context, count) {
    this.hashCode = hashCode;
    this._context = context;
    this._count = count;
  }
  incrementCount(count) {
    this._count += count;
  }
  async resubmit() {
    this._context.event.count = this._count;
    await this._context.client.config.services.queue.enqueue(this._context.event);
  }
  updateDate(date) {
    const ev = this._context.event;
    if (date && ev.date && date > ev.date) {
      ev.date = date;
    }
  }
};

// ../core/dist/plugins/default/EventExclusionPlugin.js
var EventExclusionPlugin = class {
  constructor() {
    this.priority = 45;
    this.name = "EventExclusionPlugin";
  }
  run(context) {
    const ev = context.event;
    const log = context.log;
    const settings = context.client.config.settings;
    if (ev.type === "log") {
      const minLogLevel = this.getMinLogLevel(settings, ev.source);
      const logLevel = this.getLogLevel(ev.data && ev.data[KnownEventDataKeys.Level]);
      if (logLevel !== -1 && (logLevel === 6 || logLevel < minLogLevel)) {
        log.info("Cancelling log event due to minimum log level.");
        context.cancelled = true;
      }
    } else if (ev.type === "error") {
      let error = ev.data && ev.data[KnownEventDataKeys.Error];
      while (!context.cancelled && error) {
        if (this.getTypeAndSourceSetting(settings, ev.type, error.type, true) === false) {
          log.info(`Cancelling error from excluded exception type: ${error.type}`);
          context.cancelled = true;
        }
        error = error.inner;
      }
    } else if (this.getTypeAndSourceSetting(settings, ev.type, ev.source, true) === false) {
      log.info(`Cancelling event from excluded type: ${ev.type} and source: ${ev.source}`);
      context.cancelled = true;
    }
    return Promise.resolve();
  }
  getLogLevel(level) {
    switch ((level || "").toLowerCase().trim()) {
      case "trace":
      case "true":
      case "1":
      case "yes":
        return 0;
      case "debug":
        return 1;
      case "info":
        return 2;
      case "warn":
        return 3;
      case "error":
        return 4;
      case "fatal":
        return 5;
      case "off":
      case "false":
      case "0":
      case "no":
        return 6;
      default:
        return -1;
    }
  }
  getMinLogLevel(configSettings, source) {
    return this.getLogLevel(this.getTypeAndSourceSetting(configSettings, "log", source, "other") + "");
  }
  getTypeAndSourceSetting(configSettings = {}, type, source, defaultValue) {
    if (!type) {
      return defaultValue;
    }
    if (!source) {
      source = "";
    }
    const isLog = type === "log";
    const sourcePrefix = `@@${type}:`;
    const value = configSettings[sourcePrefix + source];
    if (value) {
      return isLog ? value : toBoolean(value);
    }
    const sortedKeys = Object.keys(configSettings).sort((a, b) => b.length - a.length || a.localeCompare(b));
    for (const key of sortedKeys) {
      if (!startsWith(key.toLowerCase(), sourcePrefix)) {
        continue;
      }
      const cleanKey = key.substring(sourcePrefix.length);
      if (isMatch(source, [cleanKey])) {
        return isLog ? configSettings[key] : toBoolean(configSettings[key]);
      }
    }
    return defaultValue;
  }
};

// ../core/dist/plugins/default/ReferenceIdPlugin.js
var ReferenceIdPlugin = class {
  constructor() {
    this.priority = 20;
    this.name = "ReferenceIdPlugin";
  }
  run(context) {
    if (!context.event.reference_id && context.event.type === "error") {
      context.event.reference_id = guid().replaceAll("-", "").substring(0, 10);
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/default/SimpleErrorPlugin.js
var IgnoredErrorProperties = [
  "arguments",
  "column",
  "columnNumber",
  "description",
  "fileName",
  "message",
  "name",
  "number",
  "line",
  "lineNumber",
  "opera#sourceloc",
  "sourceId",
  "sourceURL",
  "stack",
  "stackArray",
  "stacktrace"
];
var SimpleErrorPlugin = class {
  constructor() {
    this.priority = 30;
    this.name = "SimpleErrorPlugin";
  }
  async run(context) {
    const exception = context.eventContext.getException();
    if (exception) {
      if (!context.event.type) {
        context.event.type = "error";
      }
      if (context.event.data && !context.event.data[KnownEventDataKeys.SimpleError]) {
        const error = {
          type: exception.name || "Error",
          message: exception.message,
          stack_trace: exception.stack,
          data: {}
        };
        const exclusions = context.client.config.dataExclusions.concat(IgnoredErrorProperties);
        const additionalData = stringify(exception, exclusions);
        if (!isEmpty(additionalData)) {
          error.data["@ext"] = JSON.parse(additionalData);
        }
        context.event.data[KnownEventDataKeys.SimpleError] = error;
      }
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/default/SubmissionMethodPlugin.js
var SubmissionMethodPlugin = class {
  constructor() {
    this.priority = 100;
    this.name = "SubmissionMethodPlugin";
  }
  run(context) {
    const submissionMethod = context.eventContext.getSubmissionMethod();
    if (submissionMethod && context.event.data) {
      context.event.data[KnownEventDataKeys.SubmissionMethod] = submissionMethod;
    }
    return Promise.resolve();
  }
};

// ../core/dist/plugins/EventPluginManager.js
var EventPluginManager = class {
  static async startup(context) {
    for (const plugin of context.client.config.plugins) {
      if (!plugin.startup) {
        continue;
      }
      try {
        await plugin.startup(context);
      } catch (ex) {
        context.log.error(`Error running plugin startup"${plugin.name}": ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
  }
  static async suspend(context) {
    for (const plugin of context.client.config.plugins) {
      if (!plugin.suspend) {
        continue;
      }
      try {
        await plugin.suspend(context);
      } catch (ex) {
        context.log.error(`Error running plugin suspend"${plugin.name}": ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
  }
  static async run(context) {
    for (const plugin of context.client.config.plugins) {
      if (context.cancelled) {
        break;
      }
      if (!plugin.run) {
        continue;
      }
      try {
        await plugin.run(context);
      } catch (ex) {
        context.cancelled = true;
        context.log.error(`Error running plugin "${plugin.name}": ${ex instanceof Error ? ex.message : ex + ""}. Discarding Event.`);
      }
    }
  }
  static addDefaultPlugins(config) {
    config.addPlugin(new ConfigurationDefaultsPlugin());
    config.addPlugin(new SimpleErrorPlugin());
    config.addPlugin(new ReferenceIdPlugin());
    config.addPlugin(new DuplicateCheckerPlugin());
    config.addPlugin(new EventExclusionPlugin());
    config.addPlugin(new SubmissionMethodPlugin());
  }
};

// ../core/dist/queue/DefaultEventQueue.js
var DefaultEventQueue = class {
  constructor(config, maxItems = 250) {
    this.config = config;
    this.maxItems = maxItems;
    this._handlers = [];
    this._processingQueue = false;
    this.QUEUE_PREFIX = "q:";
    this._lastFileTimestamp = 0;
    this._queue = [];
    this._loadPersistedEvents = true;
  }
  async enqueue(event) {
    const eventWillNotBeQueued = "The event will not be queued.";
    const config = this.config;
    const log = config.services.log;
    if (!config.enabled) {
      log.info(`Configuration is disabled. ${eventWillNotBeQueued}`);
      return;
    }
    if (!config.isValid) {
      log.info(`Invalid Api Key. ${eventWillNotBeQueued}`);
      return;
    }
    if (this.areQueuedItemsDiscarded()) {
      log.info(`Queue items are currently being discarded. ${eventWillNotBeQueued}`);
      return;
    }
    const file = await this.enqueueEvent(event);
    const logText = `type=${event.type} reference_id=${event.reference_id} source=${event.source} message=${event.message}`;
    log.info(`Enqueued event: ${file} (${logText})`);
  }
  async process() {
    const queueNotProcessed = "The queue will not be processed";
    const { log } = this.config.services;
    if (this._processingQueue) {
      return;
    }
    log.trace("Processing queue...");
    if (!this.config.enabled) {
      log.info(`Configuration is disabled: ${queueNotProcessed}`);
      return;
    }
    if (!this.config.isValid) {
      log.info(`Invalid Api Key: ${queueNotProcessed}`);
      return;
    }
    this._processingQueue = true;
    try {
      if (this._loadPersistedEvents) {
        if (this.config.usePersistedQueueStorage) {
          await this.loadEvents();
        }
        this._loadPersistedEvents = false;
      }
      const items = this._queue.slice(0, this.config.submissionBatchSize);
      if (!items || items.length === 0) {
        this._processingQueue = false;
        return;
      }
      log.info(`Sending ${items.length} events to ${this.config.serverUrl}`);
      const events = items.map((i) => i.event);
      const response = await this.config.services.submissionClient.submitEvents(events);
      await this.processSubmissionResponse(response, items);
      await this.eventsPosted(events, response);
      log.trace("Finished processing queue");
      this._processingQueue = false;
    } catch (ex) {
      log.error(`Error processing queue: ${ex instanceof Error ? ex.message : ex + ""}`);
      await this.suspendProcessing();
      this._processingQueue = false;
    }
  }
  startup() {
    if (!this._queueIntervalId) {
      this._queueIntervalId = setInterval(() => void this.onProcessQueue(), 1e4);
      allowProcessToExitWithoutWaitingForTimerOrInterval(this._queueIntervalId);
    }
    return Promise.resolve();
  }
  suspend() {
    clearInterval(this._queueIntervalId);
    this._queueIntervalId = void 0;
    return Promise.resolve();
  }
  async suspendProcessing(durationInMinutes, discardFutureQueuedItems, clearQueue) {
    const config = this.config;
    const currentDate = /* @__PURE__ */ new Date();
    if (!durationInMinutes || durationInMinutes <= 0) {
      durationInMinutes = Math.ceil(currentDate.getMinutes() / 15) * 15 - currentDate.getMinutes();
    }
    config.services.log.info(`Suspending processing for ${durationInMinutes} minutes.`);
    this._suspendProcessingUntil = new Date(currentDate.getTime() + durationInMinutes * 6e4);
    if (discardFutureQueuedItems) {
      this._discardQueuedItemsUntil = this._suspendProcessingUntil;
    }
    if (clearQueue) {
      await this.removeEvents(this._queue);
    }
  }
  // TODO: See if this makes sense.
  onEventsPosted(handler) {
    handler && this._handlers.push(handler);
  }
  async eventsPosted(events, response) {
    const handlers = this._handlers;
    for (const handler of handlers) {
      try {
        await handler(events, response);
      } catch (ex) {
        this.config.services.log.error(`Error calling onEventsPosted handler: ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
  }
  areQueuedItemsDiscarded() {
    return this._discardQueuedItemsUntil && this._discardQueuedItemsUntil > /* @__PURE__ */ new Date() || false;
  }
  isQueueProcessingSuspended() {
    return this._suspendProcessingUntil && this._suspendProcessingUntil > /* @__PURE__ */ new Date() || false;
  }
  async onProcessQueue() {
    if (!this.isQueueProcessingSuspended() && !this._processingQueue) {
      await this.process();
    }
  }
  async processSubmissionResponse(response, items) {
    const noSubmission = "The event will not be submitted";
    const config = this.config;
    const log = config.services.log;
    if (response.status === 202) {
      log.info(`Sent ${items.length} events`);
      await this.removeEvents(items);
      return;
    }
    if (response.status === 429 || response.rateLimitRemaining === 0 || response.status === 503) {
      log.error("Server returned service unavailable");
      await this.suspendProcessing();
      return;
    }
    if (response.status === 402) {
      log.info("Too many events have been submitted, please upgrade your plan");
      await this.suspendProcessing(0, true, true);
      return;
    }
    if (response.status === 401 || response.status === 403) {
      log.info(`Unable to authenticate, please check your configuration. ${noSubmission}`);
      await this.suspendProcessing(15);
      await this.removeEvents(items);
      return;
    }
    if (response.status === 400 || response.status === 404) {
      log.error(`Error while trying to submit data: ${response.message}`);
      await this.suspendProcessing(60 * 4);
      await this.removeEvents(items);
      return;
    }
    if (response.status === 413) {
      const message = "Event submission discarded for being too large.";
      if (config.submissionBatchSize > 1) {
        log.error(`${message} Retrying with smaller batch size.`);
        config.submissionBatchSize = Math.max(1, Math.round(config.submissionBatchSize / 1.5));
      } else {
        log.error(`${message} ${noSubmission}`);
        await this.removeEvents(items);
      }
      return;
    }
    log.error(`Error submitting events: ${response.message || "Please check the network tab for more info."}`);
    await this.suspendProcessing();
  }
  async loadEvents() {
    if (this.config.usePersistedQueueStorage) {
      const { log, storage } = this.config.services;
      try {
        const files = await storage.keys();
        for (const file of files) {
          if (file?.startsWith(this.QUEUE_PREFIX)) {
            const json = await storage.getItem(file);
            if (json)
              this._queue.push({ file, event: JSON.parse(json) });
          }
        }
      } catch (ex) {
        log.error(`Error loading queue items from storage: ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
  }
  async enqueueEvent(event) {
    this._lastFileTimestamp = Math.max(Date.now(), this._lastFileTimestamp + 1);
    const file = `${this.QUEUE_PREFIX}${this._lastFileTimestamp}.json`;
    const { log, storage } = this.config.services;
    const useStorage = this.config.usePersistedQueueStorage;
    if (this._queue.push({ file, event }) > this.maxItems) {
      log.trace("Removing oldest queue entry: maxItems exceeded");
      const item = this._queue.shift();
      if (useStorage && item) {
        try {
          await storage.removeItem(item.file);
        } catch (ex) {
          log.error(`Error removing oldest queue entry from storage: ${ex instanceof Error ? ex.message : ex + ""}`);
        }
      }
    }
    if (useStorage) {
      try {
        await storage.setItem(file, JSON.stringify(event));
      } catch (ex) {
        log.error(`Error saving queue entry to storage: ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
    return file;
  }
  async removeEvents(items) {
    const files = items.map((i) => i.file);
    if (this.config.usePersistedQueueStorage) {
      const { log, storage } = this.config.services;
      for (const file of files) {
        try {
          await storage.removeItem(file);
        } catch (ex) {
          log.error(`Error removing queue item from storage: ${ex instanceof Error ? ex.message : ex + ""}`);
        }
      }
    }
    this._queue = this._queue.filter((i) => !files.includes(i.file));
  }
};

// ../core/dist/configuration/SettingsManager.js
var ServerSettings = class {
  constructor(settings, version) {
    this.settings = settings;
    this.version = version;
  }
};
var SettingsManager = class _SettingsManager {
  static async applySavedServerSettings(config) {
    if (!config?.isValid) {
      return;
    }
    const savedSettings = await this.getSavedServerSettings(config);
    if (savedSettings) {
      config.applyServerSettings(savedSettings);
    }
  }
  static async updateSettings(config) {
    if (!config?.enabled || this._isUpdatingSettings) {
      return;
    }
    this._isUpdatingSettings = true;
    const { log, storage, submissionClient } = config.services;
    try {
      const unableToUpdateMessage = "Unable to update settings";
      if (!config.isValid) {
        log.error(`${unableToUpdateMessage}: ApiKey is not set`);
        return;
      }
      const version = config.settingsVersion;
      log.trace(`Checking for updated settings from: v${version}`);
      const response = await submissionClient.getSettings(version);
      if (response.status === 304) {
        log.trace("Settings are up-to-date");
        return;
      }
      if (!response?.success || !response.data) {
        log.warn(`${unableToUpdateMessage}: ${response.message}`);
        return;
      }
      config.applyServerSettings(response.data);
      await storage.setItem(_SettingsManager.SettingsKey, JSON.stringify(response.data));
      log.trace(`Updated settings: v${response.data.version}`);
    } catch (ex) {
      log.error(`Error updating settings: ${ex instanceof Error ? ex.message : ex + ""}`);
    } finally {
      this._isUpdatingSettings = false;
    }
  }
  static async getSavedServerSettings(config) {
    const { log, storage } = config.services;
    try {
      const settings = await storage.getItem(_SettingsManager.SettingsKey);
      return settings && JSON.parse(settings) || new ServerSettings({}, 0);
    } catch (ex) {
      log.error(`Error getting saved settings: ${ex instanceof Error ? ex.message : ex + ""}`);
      return new ServerSettings({}, 0);
    }
  }
};
SettingsManager.SettingsKey = "settings";
SettingsManager._isUpdatingSettings = false;

// ../core/dist/submission/Response.js
var Response = class {
  constructor(status, message, rateLimitRemaining, settingsVersion, data) {
    this.status = status;
    this.message = message;
    this.rateLimitRemaining = rateLimitRemaining;
    this.settingsVersion = settingsVersion;
    this.data = data;
  }
  get success() {
    return this.status >= 200 && this.status <= 299;
  }
};

// ../core/dist/submission/DefaultSubmissionClient.js
var DefaultSubmissionClient = class {
  constructor(config, fetch = globalThis.fetch?.bind(globalThis)) {
    this.config = config;
    this.fetch = fetch;
    this.RateLimitRemainingHeader = "x-ratelimit-remaining";
    this.ConfigurationVersionHeader = "x-exceptionless-configversion";
  }
  getSettings(version) {
    const url = `${this.config.serverUrl}/api/v2/projects/config?v=${version}`;
    return this.apiFetch(url, {
      method: "GET"
    });
  }
  async submitEvents(events) {
    const url = `${this.config.serverUrl}/api/v2/events`;
    const response = await this.apiFetch(url, {
      method: "POST",
      body: JSON.stringify(events)
    });
    await this.updateSettingsVersion(response.settingsVersion);
    return response;
  }
  async submitUserDescription(referenceId, description) {
    const url = `${this.config.serverUrl}/api/v2/events/by-ref/${encodeURIComponent(referenceId)}/user-description`;
    const response = await this.apiFetch(url, {
      method: "POST",
      body: JSON.stringify(description)
    });
    await this.updateSettingsVersion(response.settingsVersion);
    return response;
  }
  async submitHeartbeat(sessionIdOrUserId, closeSession) {
    const url = `${this.config.heartbeatServerUrl}/api/v2/events/session/heartbeat?id=${sessionIdOrUserId}&close=${closeSession + ""}`;
    return await this.apiFetch(url, {
      method: "GET"
    });
  }
  async updateSettingsVersion(serverSettingsVersion) {
    if (isNaN(serverSettingsVersion)) {
      this.config.services.log.error("No config version header was returned.");
    } else if (serverSettingsVersion > this.config.settingsVersion) {
      await SettingsManager.updateSettings(this.config);
    }
  }
  async apiFetch(url, options) {
    const requestOptions = {
      method: options.method,
      headers: {
        "Accept": "application/json",
        "Authorization": `Bearer ${this.config.apiKey}`,
        "User-Agent": this.config.userAgent
      },
      body: options.body ?? null
    };
    if (options.method === "POST" && this.isHeaders(requestOptions.headers)) {
      requestOptions.headers["Content-Type"] = "application/json";
    }
    const response = await this.fetch(url, requestOptions);
    const rateLimitRemaining = parseInt(response.headers.get(this.RateLimitRemainingHeader) || "", 10);
    const settingsVersion = parseInt(response.headers.get(this.ConfigurationVersionHeader) || "", 10);
    const responseText = await response.text();
    const data = responseText && responseText.length > 0 ? JSON.parse(responseText) : null;
    return new Response(response.status, response.statusText, rateLimitRemaining, settingsVersion, data);
  }
  isHeaders(headers) {
    return headers !== void 0;
  }
};

// ../core/dist/storage/InMemoryStorage.js
var InMemoryStorage = class {
  constructor() {
    this.items = /* @__PURE__ */ new Map();
  }
  length() {
    return Promise.resolve(this.items.size);
  }
  clear() {
    this.items.clear();
    return Promise.resolve();
  }
  getItem(key) {
    const value = this.items.get(key);
    return Promise.resolve(value ? value : null);
  }
  async key(index) {
    if (index < 0)
      return Promise.resolve(null);
    const keys = await this.keys();
    if (index > keys.length)
      return Promise.resolve(null);
    const key = keys[index];
    return Promise.resolve(key ? key : null);
  }
  keys() {
    return Promise.resolve(Array.from(this.items.keys()));
  }
  removeItem(key) {
    this.items.delete(key);
    return Promise.resolve();
  }
  setItem(key, value) {
    this.items.set(key, value);
    return Promise.resolve();
  }
};

// ../core/dist/storage/LocalStorage.js
var LocalStorage = class {
  constructor(prefix = "exceptionless-", storage = globalThis.localStorage) {
    this.prefix = prefix;
    this.storage = storage;
  }
  length() {
    return Promise.resolve(this.getKeys().length);
  }
  clear() {
    for (const key of this.getKeys()) {
      this.storage.removeItem(this.getKey(key));
    }
    return Promise.resolve();
  }
  getItem(key) {
    return Promise.resolve(this.storage.getItem(this.getKey(key)));
  }
  key(index) {
    const keys = this.getKeys();
    return Promise.resolve(index < keys.length ? keys[index] : null);
  }
  keys() {
    return Promise.resolve(this.getKeys());
  }
  removeItem(key) {
    this.storage.removeItem(this.getKey(key));
    return Promise.resolve();
  }
  setItem(key, value) {
    this.storage.setItem(this.getKey(key), value);
    return Promise.resolve();
  }
  getKeys() {
    return Object.keys(this.storage).filter((key) => key.startsWith(this.prefix)).map((key) => key?.substr(this.prefix.length));
  }
  getKey(key) {
    return this.prefix + key;
  }
};

// ../core/dist/configuration/Configuration.js
var Configuration = class {
  constructor() {
    this.defaultTags = [];
    this.defaultData = {};
    this.enabled = true;
    this.submissionBatchSize = 50;
    this.settings = {};
    this.settingsVersion = 0;
    this.apiKey = "";
    this._serverUrl = "https://collector.exceptionless.io";
    this.configServerUrl = "https://config.exceptionless.io";
    this.heartbeatServerUrl = "https://heartbeat.exceptionless.io";
    this._updateSettingsWhenIdleInterval = 12e4;
    this._dataExclusions = [];
    this._includePrivateInformation = true;
    this._includeUserName = true;
    this._includeMachineName = true;
    this._includeIpAddress = true;
    this._includeHeaders = true;
    this._includeCookies = true;
    this._includePostData = true;
    this._includeQueryString = true;
    this._userAgentBotPatterns = [];
    this._plugins = [];
    this._subscribers = [];
    this.usePersistedQueueStorage = false;
    this.sessionsEnabled = false;
    this.currentSessionIdentifier = null;
    this.services = {
      lastReferenceIdManager: new DefaultLastReferenceIdManager(),
      log: new NullLog(),
      storage: new InMemoryStorage(),
      queue: new DefaultEventQueue(this),
      submissionClient: new DefaultSubmissionClient(this)
    };
    EventPluginManager.addDefaultPlugins(this);
  }
  /**
   * Returns true if the apiKey is valid.
   */
  get isValid() {
    return this.apiKey?.length >= 10;
  }
  /**
   * The server url that all events will be sent to.
   */
  get serverUrl() {
    return this._serverUrl;
  }
  /**
   * The server url that all events will be sent to.
   */
  set serverUrl(value) {
    if (value) {
      this._serverUrl = value;
      this.configServerUrl = value;
      this.heartbeatServerUrl = value;
    }
  }
  /**
   * How often the client should check for updated server settings when idle. The default is every 2 minutes.
   */
  get updateSettingsWhenIdleInterval() {
    return this._updateSettingsWhenIdleInterval;
  }
  /**
   * How often the client should check for updated server settings when idle. The default is every 2 minutes.
   */
  set updateSettingsWhenIdleInterval(value) {
    if (typeof value !== "number") {
      return;
    }
    if (value <= 0) {
      value = -1;
    } else if (value > 0 && value < 12e4) {
      value = 12e4;
    }
    this._updateSettingsWhenIdleInterval = value;
  }
  /**
   *  A list of exclusion patterns that will automatically remove any data that
   *  matches them from any data submitted to the server.
   *
   *  For example, entering CreditCard will remove any extended data properties,
   *  form fields, cookies and query parameters from the report.
   */
  get dataExclusions() {
    const exclusions = this.settings["@@DataExclusions"];
    return this._dataExclusions.concat(exclusions && exclusions.split(",") || []);
  }
  /**
   * Add items to the list of exclusion patterns that will automatically remove any
   * data that matches them from any data submitted to the server.
   *
   * For example, entering CreditCard will remove any extended data properties, form
   * fields, cookies and query parameters from the report.
   */
  addDataExclusions(...exclusions) {
    this._dataExclusions = [...this._dataExclusions, ...exclusions];
  }
  /**
   * Gets a value indicating whether to include private information about the local machine.
   */
  get includePrivateInformation() {
    return this._includePrivateInformation;
  }
  /**
   * Sets a value indicating whether to include private information about the local machine
   */
  set includePrivateInformation(value) {
    const val = value === true;
    this._includePrivateInformation = val;
    this._includeUserName = val;
    this._includeMachineName = val;
    this._includeIpAddress = val;
    this._includeHeaders = val;
    this._includeCookies = val;
    this._includePostData = val;
    this._includeQueryString = val;
  }
  /**
   * Gets a value indicating whether to include User Name.
   */
  get includeUserName() {
    return this._includeUserName;
  }
  /**
   * Sets a value indicating whether to include User Name.
   */
  set includeUserName(value) {
    this._includeUserName = value === true;
  }
  /**
   * Gets a value indicating whether to include MachineName in MachineInfo.
   */
  get includeMachineName() {
    return this._includeMachineName;
  }
  /**
   * Sets a value indicating whether to include MachineName in MachineInfo.
   */
  set includeMachineName(value) {
    this._includeMachineName = value === true;
  }
  /**
   * Gets a value indicating whether to include Ip Addresses in MachineInfo and RequestInfo.
   */
  get includeIpAddress() {
    return this._includeIpAddress;
  }
  /**
   * Sets a value indicating whether to include Ip Addresses in MachineInfo and RequestInfo.
   */
  set includeIpAddress(value) {
    this._includeIpAddress = value === true;
  }
  /**
   * Gets a value indicating whether to include Headers.
   * NOTE: DataExclusions are applied to all Header keys when enabled.
   */
  get includeHeaders() {
    return this._includeHeaders;
  }
  /**
   * Sets a value indicating whether to include Headers.
   * NOTE: DataExclusions are applied to all Headers keys when enabled.
   */
  set includeHeaders(value) {
    this._includeHeaders = value === true;
  }
  /**
   * Gets a value indicating whether to include Cookies.
   * NOTE: DataExclusions are applied to all Cookie keys when enabled.
   */
  get includeCookies() {
    return this._includeCookies;
  }
  /**
   * Sets a value indicating whether to include Cookies.
   * NOTE: DataExclusions are applied to all Cookie keys when enabled.
   */
  set includeCookies(value) {
    this._includeCookies = value === true;
  }
  /**
   * Gets a value indicating whether to include Form/POST Data.
   * NOTE: DataExclusions are only applied to Form data keys when enabled.
   */
  get includePostData() {
    return this._includePostData;
  }
  /**
   * Sets a value indicating whether to include Form/POST Data.
   * NOTE: DataExclusions are only applied to Form data keys when enabled.
   */
  set includePostData(value) {
    this._includePostData = value === true;
  }
  /**
   * Gets a value indicating whether to include query string information.
   * NOTE: DataExclusions are applied to all Query String keys when enabled.
   */
  get includeQueryString() {
    return this._includeQueryString;
  }
  /**
   * Sets a value indicating whether to include query string information.
   * NOTE: DataExclusions are applied to all Query String keys when enabled.
   */
  set includeQueryString(value) {
    this._includeQueryString = value === true;
  }
  /**
   * A list of user agent patterns that will cause any event with a matching user agent to not be submitted.
   *
   * For example, entering *Bot* will cause any events that contains a user agent of Bot will not be submitted.
   */
  get userAgentBotPatterns() {
    const patterns = this.settings["@@UserAgentBotPatterns"];
    return this._userAgentBotPatterns.concat(patterns && patterns.split(",") || []);
  }
  /**
   * Add items to the list of user agent patterns that will cause any event with a matching user agent to not be submitted.
   *
   * For example, entering *Bot* will cause any events that contains a user agent of Bot will not be submitted.
   */
  addUserAgentBotPatterns(...userAgentBotPatterns) {
    this._userAgentBotPatterns = [
      ...this._userAgentBotPatterns,
      ...userAgentBotPatterns
    ];
  }
  /**
   * The list of plugins that will be used in this configuration.
   */
  get plugins() {
    return this._plugins.sort((p1, p2) => {
      if (p1 == null && p2 == null) {
        return 0;
      }
      if (p1?.priority == null) {
        return -1;
      }
      if (p2?.priority == null) {
        return 1;
      }
      if (p1.priority == p2.priority) {
        return 0;
      }
      return p1.priority > p2.priority ? 1 : -1;
    });
  }
  addPlugin(pluginOrName, priority, pluginAction) {
    const plugin = pluginAction ? { name: pluginOrName, priority, run: pluginAction } : pluginOrName;
    if (!plugin || !(plugin.startup || plugin.run)) {
      this.services.log.error("Add plugin failed: startup or run method not defined");
      return;
    }
    if (!plugin.name) {
      plugin.name = guid();
    }
    if (!plugin.priority) {
      plugin.priority = 0;
    }
    if (!this._plugins.find((f) => f.name === plugin.name)) {
      this._plugins.push(plugin);
    }
  }
  /**
   * Remove an plugin by key from this configuration.
   */
  removePlugin(pluginOrName) {
    const name = typeof pluginOrName === "string" ? pluginOrName : pluginOrName.name || "";
    if (!name) {
      this.services.log.error("Remove plugin failed: Plugin name not defined");
      return;
    }
    const plugins = this._plugins;
    for (let index = 0; index < plugins.length; index++) {
      if (plugins[index].name === name) {
        plugins.splice(index, 1);
        break;
      }
    }
  }
  /**
   * The application version for events.
   */
  get version() {
    return this.defaultData[KnownEventDataKeys.Version];
  }
  /**
   * Set the application version for events.
   */
  set version(version) {
    if (version) {
      this.defaultData[KnownEventDataKeys.Version] = version;
    } else {
      delete this.defaultData[KnownEventDataKeys.Version];
    }
  }
  setUserIdentity(userInfoOrIdentity, name) {
    const userInfo = typeof userInfoOrIdentity !== "string" ? userInfoOrIdentity : { identity: userInfoOrIdentity, name };
    const shouldRemove = !userInfo || !userInfo.identity && !userInfo.name;
    if (shouldRemove) {
      delete this.defaultData[KnownEventDataKeys.UserInfo];
    } else {
      this.defaultData[KnownEventDataKeys.UserInfo] = userInfo;
    }
    this.services.log.info(`user identity: ${shouldRemove ? "null" : userInfo.identity}`);
  }
  /**
   * Used to identify the client that sent the events to the server.
   */
  get userAgent() {
    return "exceptionless-js/3.0.5";
  }
  /**
   * Use localStorage for persisting things like server configuration cache and persisted queue entries (depends on usePersistedQueueStorage).
   */
  useLocalStorage() {
    if (globalThis?.localStorage) {
      this.services.storage = new LocalStorage();
    }
  }
  /**
   *
   * @param sendHeartbeats Controls whether heartbeat events are sent on an interval.
   * @param heartbeatInterval The interval at which heartbeats are sent after the last sent event. The default is 1 minutes.
   * @param useSessionIdManagement Allows you to manually control the session id. This is only recommended for single user desktop environments.
   */
  useSessions(sendHeartbeats = true, heartbeatInterval = 6e4, useSessionIdManagement = false) {
    this.sessionsEnabled = true;
    if (useSessionIdManagement) {
      this.addPlugin(new SessionIdManagementPlugin());
    }
    const plugin = new HeartbeatPlugin(heartbeatInterval);
    if (sendHeartbeats) {
      this.addPlugin(plugin);
    } else {
      this.removePlugin(plugin);
    }
  }
  applyServerSettings(serverSettings) {
    if (!this.originalSettings) {
      this.originalSettings = JSON.parse(JSON.stringify(this.settings));
    }
    this.services.log.trace(`Applying saved settings: v${serverSettings.version}`);
    this.settings = Object.assign(this.originalSettings, serverSettings.settings);
    this.settingsVersion = serverSettings.version;
    this.notifySubscribers();
  }
  // TODO: Support a min log level.
  useDebugLogger() {
    this.services.log = new ConsoleLog();
  }
  subscribeServerSettingsChange(handler) {
    handler && this._subscribers.push(handler);
  }
  notifySubscribers() {
    for (const handler of this._subscribers) {
      try {
        handler(this);
      } catch (ex) {
        this.services.log.error(`Error calling subscribe handler: ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
  }
};

// ../core/dist/models/EventContext.js
var KnownContextKeys;
(function(KnownContextKeys2) {
  KnownContextKeys2["Exception"] = "@@_Exception";
  KnownContextKeys2["IsUnhandledError"] = "@@_IsUnhandledError";
  KnownContextKeys2["SubmissionMethod"] = "@@_SubmissionMethod";
})(KnownContextKeys || (KnownContextKeys = {}));
var EventContext = class {
  getException() {
    return this[KnownContextKeys.Exception] || null;
  }
  setException(exception) {
    if (exception) {
      this[KnownContextKeys.Exception] = exception;
    }
  }
  get hasException() {
    return !!this[KnownContextKeys.Exception];
  }
  markAsUnhandledError() {
    this[KnownContextKeys.IsUnhandledError] = true;
  }
  get isUnhandledError() {
    return !!this[KnownContextKeys.IsUnhandledError];
  }
  getSubmissionMethod() {
    return this[KnownContextKeys.SubmissionMethod] || null;
  }
  setSubmissionMethod(method) {
    if (method) {
      this[KnownContextKeys.SubmissionMethod] = method;
    }
  }
};

// ../core/dist/plugins/PluginContext.js
var PluginContext = class {
  constructor(client) {
    this.client = client;
  }
  get log() {
    return this.client.config.services.log;
  }
};

// ../core/dist/plugins/EventPluginContext.js
var EventPluginContext = class {
  constructor(client, event, eventContext) {
    this.client = client;
    this.event = event;
    this.eventContext = eventContext;
    this.cancelled = false;
    if (!this.eventContext)
      this.eventContext = new EventContext();
  }
  get log() {
    return this.client.config.services.log;
  }
};

// ../core/dist/EventBuilder.js
var EventBuilder = class {
  constructor(event, client, context) {
    this._validIdentifierErrorMessage = "must contain between 8 and 100 alphanumeric or '-' characters.";
    this.target = event;
    this.client = client;
    this.context = context || new EventContext();
  }
  setType(type) {
    if (type) {
      this.target.type = type;
    }
    return this;
  }
  setSource(source) {
    if (source) {
      this.target.source = source;
    }
    return this;
  }
  setReferenceId(referenceId) {
    if (!this.isValidIdentifier(referenceId)) {
      throw new Error(`ReferenceId ${this._validIdentifierErrorMessage}`);
    }
    this.target.reference_id = referenceId;
    return this;
  }
  /**
   * Allows you to reference a parent event by its ReferenceId property. This allows you to have parent and child relationships.
   * @param name Reference name
   * @param id The reference id that points to a specific event
   */
  setEventReference(name, id) {
    if (!name) {
      throw new Error("Invalid name");
    }
    if (!id || !this.isValidIdentifier(id)) {
      throw new Error(`Id ${this._validIdentifierErrorMessage}`);
    }
    this.setProperty("@ref:" + name, id);
    return this;
  }
  setMessage(message) {
    if (message) {
      this.target.message = message;
    }
    return this;
  }
  setGeo(latitude, longitude) {
    if (latitude < -90 || latitude > 90) {
      throw new Error("Must be a valid latitude value between -90.0 and 90.0.");
    }
    if (longitude < -180 || longitude > 180) {
      throw new Error("Must be a valid longitude value between -180.0 and 180.0.");
    }
    this.target.geo = `${latitude},${longitude}`;
    return this;
  }
  setUserIdentity(userInfoOrIdentity, name) {
    const userInfo = typeof userInfoOrIdentity !== "string" ? userInfoOrIdentity : { identity: userInfoOrIdentity, name };
    if (!userInfo || !userInfo.identity && !userInfo.name) {
      return this;
    }
    this.setProperty(KnownEventDataKeys.UserInfo, userInfo);
    return this;
  }
  /**
   * Sets the user"s description of the event.
   *
   * @param emailAddress The email address
   * @param description The user"s description of the event.
   */
  setUserDescription(emailAddress, description) {
    if (emailAddress && description) {
      this.setProperty(KnownEventDataKeys.UserDescription, {
        email_address: emailAddress,
        description
      });
    }
    return this;
  }
  /**
   * Changes default stacking behavior by setting manual
   * stacking information.
   * @param signatureData A dictionary of strings to use for stacking.
   * @param title An optional title for the stacking information.
   */
  setManualStackingInfo(signatureData, title) {
    if (signatureData) {
      const stack = { signature_data: signatureData };
      if (title) {
        stack.title = title;
      }
      this.setProperty(KnownEventDataKeys.ManualStackingInfo, stack);
    }
    return this;
  }
  /**
   * Changes default stacking behavior by setting the stacking key.
   * @param manualStackingKey The manual stacking key.
   * @param title An optional title for the stacking information.
   */
  setManualStackingKey(manualStackingKey, title) {
    if (manualStackingKey) {
      const data = { ManualStackingKey: manualStackingKey };
      this.setManualStackingInfo(data, title);
    }
    return this;
  }
  /**
   * Sets the event value.
   * @param value The value of the event.
   */
  setValue(value) {
    if (value) {
      this.target.value = value;
    }
    return this;
  }
  addTags(...tags) {
    this.target.tags = [...this.target.tags || [], ...tags];
    return this;
  }
  /**
   * Adds the object to extended data. Uses @excludedPropertyNames
   * to exclude data from being included in the event.
   * @param name The name of the object to add.
   * @param value The data object to add.
   * @param maxDepth The max depth of the object to include.
   * @param excludedPropertyNames Any property names that should be excluded.
   */
  setProperty(name, value, maxDepth, excludedPropertyNames) {
    if (!name || (value === void 0 || value == null)) {
      return this;
    }
    if (!this.target.data) {
      this.target.data = {};
    }
    const exclusions = this.client.config.dataExclusions.concat(excludedPropertyNames || []);
    const json = stringify(value, exclusions, maxDepth);
    if (!isEmpty(json)) {
      this.target.data[name] = JSON.parse(json);
    }
    return this;
  }
  setContextProperty(name, value) {
    this.context[name] = value;
    return this;
  }
  markAsCritical(critical) {
    if (critical) {
      this.addTags("Critical");
    }
    return this;
  }
  submit() {
    return this.client.submitEvent(this.target, this.context);
  }
  isValidIdentifier(value) {
    if (!value) {
      return true;
    }
    if (value.length < 8 || value.length > 100) {
      return false;
    }
    for (let index = 0; index < value.length; index++) {
      const code = value.charCodeAt(index);
      const isDigit = code >= 48 && code <= 57;
      const isLetter = code >= 65 && code <= 90 || code >= 97 && code <= 122;
      const isMinus = code === 45;
      if (!(isDigit || isLetter) && !isMinus) {
        return false;
      }
    }
    return true;
  }
};

// ../core/dist/ExceptionlessClient.js
var ExceptionlessClient = class {
  constructor(config = new Configuration()) {
    this.config = config;
    this._initialized = false;
  }
  /** Resume background submission, resume any timers. */
  async startup(configurationOrApiKey) {
    if (configurationOrApiKey && !this._initialized) {
      this._initialized = true;
      if (typeof configurationOrApiKey === "string") {
        this.config.apiKey = configurationOrApiKey;
      } else {
        configurationOrApiKey(this.config);
      }
      this.config.services.queue.onEventsPosted(() => Promise.resolve(this.updateSettingsTimer()));
      await SettingsManager.applySavedServerSettings(this.config);
    }
    if (!this.config.isValid) {
      this.config.services.log.warn("Exceptionless is not configured and will not process events.");
      return;
    }
    this.updateSettingsTimer(!!configurationOrApiKey);
    await EventPluginManager.startup(new PluginContext(this));
    const { queue } = this.config.services;
    await queue.startup();
    if (this.config.usePersistedQueueStorage) {
      await queue.process();
    }
    if (this.config.sessionsEnabled) {
      await this.submitSessionStart();
    }
  }
  /** Submit events, pause any timers and go into low power mode. */
  async suspend() {
    await EventPluginManager.suspend(new PluginContext(this));
    const { queue } = this.config.services;
    await queue.suspend();
    await queue.process();
    this.suspendSettingsTimer();
  }
  suspendSettingsTimer() {
    clearTimeout(this._timeoutId);
    this._timeoutId = void 0;
    clearInterval(this._intervalId);
    this._intervalId = void 0;
  }
  async processQueue() {
    await this.config.services.queue.process();
  }
  updateSettingsTimer(startingUp = false) {
    this.suspendSettingsTimer();
    if (!this.config.isValid) {
      return;
    }
    const interval = this.config.updateSettingsWhenIdleInterval;
    if (interval > 0) {
      let initialDelay = interval;
      if (startingUp) {
        initialDelay = this.config.settingsVersion > 0 ? 15e3 : 5e3;
      }
      this.config.services.log.info(`Update settings every ${interval}ms (${initialDelay || 0}ms delay)`);
      const updateSettings = () => void SettingsManager.updateSettings(this.config);
      if (initialDelay < interval) {
        this._timeoutId = setTimeout(updateSettings, initialDelay);
        allowProcessToExitWithoutWaitingForTimerOrInterval(this._timeoutId);
      }
      this._intervalId = setInterval(updateSettings, interval);
      allowProcessToExitWithoutWaitingForTimerOrInterval(this._intervalId);
    }
  }
  createException(exception) {
    const pluginContextData = new EventContext();
    pluginContextData.setException(exception);
    return this.createEvent(pluginContextData).setType("error");
  }
  submitException(exception) {
    return this.createException(exception).submit();
  }
  createUnhandledException(exception, submissionMethod) {
    const builder = this.createException(exception);
    builder.context.markAsUnhandledError();
    builder.context.setSubmissionMethod(submissionMethod || "");
    return builder;
  }
  submitUnhandledException(exception, submissionMethod) {
    return this.createUnhandledException(exception, submissionMethod).submit();
  }
  createFeatureUsage(feature) {
    return this.createEvent().setType("usage").setSource(feature);
  }
  submitFeatureUsage(feature) {
    return this.createFeatureUsage(feature).submit();
  }
  createLog(sourceOrMessage, message, level) {
    let builder = this.createEvent().setType("log");
    if (level) {
      builder = builder.setSource(sourceOrMessage).setMessage(message).setProperty(KnownEventDataKeys.Level, level);
    } else if (message) {
      builder = builder.setSource(sourceOrMessage).setMessage(message);
    } else {
      builder = builder.setMessage(sourceOrMessage);
      try {
        const caller = this.createLog.caller;
        builder = builder.setSource(caller && caller.caller && caller.caller.name);
      } catch (ex) {
        this.config.services.log.trace(`Unable to resolve log source: ${ex instanceof Error ? ex.message : ex + ""}`);
      }
    }
    return builder;
  }
  submitLog(sourceOrMessage, message, level) {
    return this.createLog(sourceOrMessage, message, level).submit();
  }
  createNotFound(resource) {
    return this.createEvent().setType("404").setSource(resource);
  }
  submitNotFound(resource) {
    return this.createNotFound(resource).submit();
  }
  createSessionStart() {
    return this.createEvent().setType("session");
  }
  submitSessionStart() {
    return this.createSessionStart().submit();
  }
  async submitSessionEnd(sessionIdOrUserId) {
    const { currentSessionIdentifier, enabled, isValid, services } = this.config;
    const sessionId = sessionIdOrUserId || currentSessionIdentifier;
    if (sessionId && enabled && isValid) {
      services.log.info(`Submitting session end: ${sessionId}`);
      await services.submissionClient.submitHeartbeat(sessionId, true);
    }
  }
  async submitSessionHeartbeat(sessionIdOrUserId) {
    const { currentSessionIdentifier, enabled, isValid, services } = this.config;
    const sessionId = sessionIdOrUserId || currentSessionIdentifier;
    if (sessionId && enabled && isValid) {
      services.log.info(`Submitting session heartbeat: ${sessionId}`);
      await services.submissionClient.submitHeartbeat(sessionId, false);
    }
  }
  createEvent(context) {
    return new EventBuilder({ date: /* @__PURE__ */ new Date() }, this, context);
  }
  /**
   * Submits the event to the server.
   *
   * @param event The event
   * @param context Contextual data used by event plugins to enrich the event details
   */
  async submitEvent(event, context) {
    const pluginContext = new EventPluginContext(this, event, context ?? new EventContext());
    if (!event) {
      pluginContext.cancelled = true;
      return pluginContext;
    }
    if (!this.config.enabled || !this.config.isValid) {
      this.config.services.log.info("Event submission is currently disabled.");
      pluginContext.cancelled = true;
      return pluginContext;
    }
    if (!event.data) {
      event.data = {};
    }
    if (!event.tags || !event.tags.length) {
      event.tags = [];
    }
    await EventPluginManager.run(pluginContext);
    if (pluginContext.cancelled) {
      return pluginContext;
    }
    const ev = pluginContext.event;
    if (!ev.type || ev.type.length === 0) {
      ev.type = "log";
    }
    if (!ev.date) {
      ev.date = /* @__PURE__ */ new Date();
    }
    await this.config.services.queue.enqueue(ev);
    if (ev.reference_id && ev.reference_id.length > 0) {
      pluginContext.log.info(`Setting last reference id "${ev.reference_id}"`);
      this.config.services.lastReferenceIdManager.setLast(ev.reference_id);
    }
    return pluginContext;
  }
  /**
   * Updates the user"s email address and description of an event for the specified reference id.
   * @param referenceId The reference id of the event to update.
   * @param email The user"s email address to set on the event.
   * @param description The user"s description of the event.
   * @param callback The submission response.
   */
  async updateUserEmailAndDescription(referenceId, email, description) {
    if (!referenceId || !email || !description || !this.config.enabled || !this.config.isValid) {
      return;
    }
    const userDescription = { email_address: email, description };
    const response = await this.config.services.submissionClient.submitUserDescription(referenceId, userDescription);
    if (!response.success) {
      this.config.services.log.error(`Failed to submit user email and description for event "${referenceId}": ${response.status} ${response.message}`);
    }
  }
  /**
   * Gets the last event client id that was submitted to the server.
   * @returns {string} The event client id.
   */
  getLastReferenceId() {
    return this.config.services.lastReferenceIdManager.getLast();
  }
};

// ../browser/dist/plugins/BrowserErrorPlugin.js
var import_stacktrace_js = __toESM(require_stacktrace(), 1);
var BrowserErrorPlugin = class {
  constructor() {
    this.priority = 30;
    this.name = "BrowserErrorPlugin";
  }
  async run(context) {
    const exception = context.eventContext.getException();
    if (exception) {
      if (!context.event.type) {
        context.event.type = "error";
      }
      if (context.event.data && !context.event.data[KnownEventDataKeys.Error]) {
        const result = await this.parse(exception);
        if (result) {
          const exclusions = context.client.config.dataExclusions.concat(IgnoredErrorProperties);
          const additionalData = stringify(exception, exclusions);
          if (!isEmpty(additionalData)) {
            if (!result.data) {
              result.data = {};
            }
            result.data["@ext"] = JSON.parse(additionalData);
          }
          context.event.data[KnownEventDataKeys.Error] = result;
        }
      }
    }
  }
  async parse(exception) {
    function getParameters(parameters) {
      const params = (typeof parameters === "string" ? [parameters] : parameters) || [];
      const items = [];
      for (const param of params) {
        items.push({ name: param });
      }
      return items;
    }
    function getStackFrames(stackFrames) {
      const ANONYMOUS = "<anonymous>";
      const frames = [];
      for (const frame of stackFrames) {
        const fileName = frame.getFileName();
        frames.push({
          name: (frame.getFunctionName() || ANONYMOUS).replace("?", ANONYMOUS),
          parameters: getParameters(frame.getArgs()),
          file_name: fileName,
          line_number: frame.getLineNumber() || 0,
          column: frame.getColumnNumber() || 0,
          data: {
            is_native: frame.getIsNative() || fileName && fileName[0] !== "/" && fileName[0] !== "."
          }
        });
      }
      return frames;
    }
    const result = exception.stack ? await (0, import_stacktrace_js.fromError)(exception) : [];
    if (!result) {
      throw new Error("Unable to parse the exception stack trace");
    }
    return Promise.resolve({
      type: exception.name || "Error",
      message: exception.message,
      stack_trace: getStackFrames(result || [])
    });
  }
};

// ../browser/dist/plugins/BrowserGlobalHandlerPlugin.js
var BrowserGlobalHandlerPlugin = class {
  constructor() {
    this.priority = 100;
    this.name = "BrowserGlobalHandlerPlugin";
    this._client = null;
  }
  startup(context) {
    if (this._client || typeof window !== "object") {
      return Promise.resolve();
    }
    this._client = context.client;
    window.addEventListener("error", (event) => {
      void this._client?.submitUnhandledException(this.getError(event), "onerror");
    });
    window.addEventListener("unhandledrejection", (event) => {
      let reason = event.reason;
      if (!(reason instanceof Error)) {
        try {
          const detailReason = event.detail?.reason;
          if (detailReason) {
            reason = detailReason;
          }
        } catch (ex) {
        }
      }
      if (!(reason instanceof Error)) {
        try {
          const error2 = event.reason.error;
          if (error2) {
            reason = error2;
          }
        } catch (ex) {
        }
      }
      const error = toError(reason, "Unhandled rejection");
      void this._client?.submitUnhandledException(error, "onunhandledrejection");
    });
    if (typeof $ !== "undefined" && $(document)) {
      $(document).ajaxError((_, xhr, settings, error) => {
        if (xhr.status === 404) {
          void this._client?.submitNotFound(settings.url);
        } else if (xhr.status !== 401) {
          void this._client?.createUnhandledException(toError(error), "JQuery.ajaxError").setSource(settings.url).setProperty("status", xhr.status).setProperty("request", settings.data).setProperty("response", xhr.responseText?.slice(0, 1024)).submit();
        }
      });
    }
    return Promise.resolve();
  }
  getError(event) {
    const { error, message, filename, lineno, colno } = event;
    if (typeof error === "object") {
      return error;
    }
    let name = "Error";
    let msg = message || event.error;
    if (msg) {
      const errorNameRegex = /^(?:[Uu]ncaught (?:exception: )?)?(?:((?:Aggregate|Eval|Internal|Range|Reference|Syntax|Type|URI|)Error): )?(.*)$/i;
      const regexResult = errorNameRegex.exec(msg);
      if (regexResult) {
        const [, errorName, errorMessage] = regexResult;
        if (errorName) {
          name = errorName;
        }
        if (errorMessage) {
          msg = errorMessage;
        }
      }
    }
    const ex = new Error(msg || "Script error.");
    ex.name = name;
    ex.stack = `at ${filename || ""}:${!isNaN(lineno) ? lineno : 0}${!isNaN(colno) ? `:${colno}` : ""}`;
    return ex;
  }
};

// ../browser/dist/plugins/BrowserIgnoreExtensionErrorsPlugin.js
var BrowserIgnoreExtensionErrorsPlugin = class {
  constructor() {
    this.priority = 15;
    this.name = "BrowserIgnoreExtensionErrorsPlugin";
  }
  async run(context) {
    const exception = context.eventContext.getException();
    if (exception?.stack && exception.stack.includes("-extension://")) {
      context.log.info("Ignoring event with error stack containing browser extension");
      context.cancelled = true;
    }
    return Promise.resolve();
  }
};

// ../browser/dist/plugins/BrowserLifeCyclePlugin.js
var BrowserLifeCyclePlugin = class {
  constructor() {
    this.priority = 105;
    this.name = "BrowserLifeCyclePlugin";
    this._client = null;
  }
  startup(context) {
    if (this._client || typeof document !== "object") {
      return Promise.resolve();
    }
    this._client = context.client;
    globalThis.addEventListener("beforeunload", () => {
      if (this._client?.config.sessionsEnabled) {
        void this._client?.submitSessionEnd();
      }
      void this._client?.suspend();
    });
    document.addEventListener("visibilitychange", () => {
      if (document.visibilityState === "visible") {
        void this._client?.startup();
      } else {
        void this._client?.suspend();
      }
    });
    return Promise.resolve();
  }
};

// ../browser/dist/plugins/BrowserModuleInfoPlugin.js
var BrowserModuleInfoPlugin = class {
  constructor() {
    this.priority = 50;
    this.name = "BrowserModuleInfoPlugin";
  }
  startup() {
    if (!this._modules) {
      this._modules = this.getModules();
    }
    return Promise.resolve();
  }
  run(context) {
    const error = context.event.data?.[KnownEventDataKeys.Error];
    if (error && !error?.modules && this._modules?.length) {
      error.modules = this._modules;
    }
    return Promise.resolve();
  }
  getModules() {
    if (typeof document !== "object" || !document.getElementsByTagName) {
      return;
    }
    const modules = [];
    const scripts = document.getElementsByTagName("script");
    if (scripts && scripts.length > 0) {
      for (let index = 0; index < scripts.length; index++) {
        if (scripts[index].src) {
          modules.push({
            module_id: index,
            name: scripts[index].src.split("?")[0],
            version: parseVersion(scripts[index].src)
          });
        } else if (scripts[index].innerHTML) {
          modules.push({
            module_id: index,
            name: "Script Tag",
            version: getHashCode(scripts[index].innerHTML).toString()
          });
        }
      }
    }
    return modules;
  }
};

// ../browser/dist/plugins/BrowserRequestInfoPlugin.js
var BrowserRequestInfoPlugin = class {
  constructor() {
    this.priority = 70;
    this.name = "BrowserRequestInfoPlugin";
  }
  run(context) {
    if (context.event.data && !context.event.data[KnownEventDataKeys.RequestInfo]) {
      const requestInfo = this.getRequestInfo(context);
      if (requestInfo) {
        if (isMatch(requestInfo.user_agent, context.client.config.userAgentBotPatterns)) {
          context.log.info("Cancelling event as the request user agent matches a known bot pattern");
          context.cancelled = true;
        } else {
          context.event.data[KnownEventDataKeys.RequestInfo] = requestInfo;
        }
      }
    }
    return Promise.resolve();
  }
  getRequestInfo(context) {
    if (typeof document !== "object" || typeof navigator !== "object" || typeof location !== "object") {
      return;
    }
    const config = context.client.config;
    const exclusions = config.dataExclusions;
    const requestInfo = {
      user_agent: navigator.userAgent,
      is_secure: location.protocol === "https:",
      host: location.hostname,
      port: location.port && location.port !== "" ? parseInt(location.port, 10) : 80,
      path: location.pathname
    };
    if (config.includeCookies) {
      requestInfo.cookies = getCookies(document.cookie, exclusions);
    }
    if (config.includeQueryString) {
      requestInfo.query_string = parseQueryString(location.search.substring(1), exclusions);
    }
    if (document.referrer && document.referrer !== "") {
      requestInfo.referrer = document.referrer;
    }
    return requestInfo;
  }
};

// ../browser/dist/BrowserExceptionlessClient.js
var BrowserExceptionlessClient = class extends ExceptionlessClient {
  async startup(configurationOrApiKey) {
    const config = this.config;
    if (configurationOrApiKey && !this._initialized) {
      config.useLocalStorage();
      config.addPlugin(new BrowserGlobalHandlerPlugin());
      config.addPlugin(new BrowserIgnoreExtensionErrorsPlugin());
      config.addPlugin(new BrowserLifeCyclePlugin());
      config.addPlugin(new BrowserModuleInfoPlugin());
      config.addPlugin(new BrowserRequestInfoPlugin());
      config.addPlugin(new BrowserErrorPlugin());
      config.removePlugin(new SimpleErrorPlugin());
    }
    await super.startup(configurationOrApiKey);
  }
};

// ../browser/dist/index.js
var Exceptionless = new BrowserExceptionlessClient();

// src/index.ts
angular.module("exceptionless", []).constant("$ExceptionlessClient", Exceptionless).factory("exceptionlessHttpInterceptor", ["$location", "$q", "$ExceptionlessClient", ($location, $q, $ExceptionlessClient) => {
  return {
    responseError: function responseError(response) {
      if (response.status === 404) {
        void $ExceptionlessClient.submitNotFound(response.config.url);
      } else if (response.status !== 401) {
        const message = `[${response.status}] ${response.data?.Message ?? response.config.url}`;
        void $ExceptionlessClient.createUnhandledException(new Error(message), "errorHttpInterceptor").setSource(response.config.url).setProperty("response", response).setProperty("referrer", $location.absUrl()).submit();
      }
      return $q.reject(response);
    }
  };
}]).config(["$httpProvider", "$provide", "$ExceptionlessClient", ($httpProvider, $provide, $ExceptionlessClient) => {
  $httpProvider.interceptors.push("exceptionlessHttpInterceptor");
  $provide.decorator("$exceptionHandler", ["$delegate", ($delegate) => {
    return (exception, cause) => {
      $delegate(exception, cause);
      void $ExceptionlessClient.createUnhandledException(exception, "$exceptionHandler").setMessage(cause).submit();
    };
  }]);
  $provide.decorator("$log", ["$delegate", ($delegate) => {
    function decorateRegularCall(property, logLevel) {
      const previousFn = $delegate[property];
      return $delegate[property] = (...args) => {
        if (angular.mock) {
          $delegate[property].logs = [];
        }
        previousFn.apply(null, args);
        if (args[0] && args[0].length > 0) {
          void $ExceptionlessClient.submitLog(void 0, args[0], logLevel);
        }
      };
    }
    $delegate.log = decorateRegularCall("log", "Trace");
    $delegate.info = decorateRegularCall("info", "Info");
    $delegate.warn = decorateRegularCall("warn", "Warn");
    $delegate.debug = decorateRegularCall("debug", "Debug");
    $delegate.error = decorateRegularCall("error", "Error");
    return $delegate;
  }]);
}]).run(["$rootScope", "$ExceptionlessClient", ($rootScope, $ExceptionlessClient) => {
  $rootScope.$on("$routeChangeSuccess", (_event, next, current) => {
    if (!current) {
      return;
    }
    void $ExceptionlessClient.createFeatureUsage(current.name).setProperty("next", next).setProperty("current", current).submit();
  });
  $rootScope.$on("$routeChangeError", (_event, current, previous, rejection) => {
    const error = toError(rejection, "Route Change Error");
    void $ExceptionlessClient.createUnhandledException(error, "$routeChangeError").setProperty("current", current).setProperty("previous", previous).submit();
  });
  $rootScope.$on("$stateChangeSuccess", (_event, toState, toParams, fromState, fromParams) => {
    if (!toState || toState.name === "otherwise") {
      return;
    }
    void $ExceptionlessClient.createFeatureUsage(toState.controller || toState.name).setProperty("toState", toState).setProperty("toParams", toParams).setProperty("fromState", fromState).setProperty("fromParams", fromParams).submit();
  });
  $rootScope.$on("$stateNotFound", (_event, unfoundState, fromState, fromParams) => {
    if (!unfoundState) {
      return;
    }
    void $ExceptionlessClient.createNotFound(unfoundState.to).setProperty("unfoundState", unfoundState).setProperty("fromState", fromState).setProperty("fromParams", fromParams).submit();
  });
  const stateChangeError = "$stateChangeError";
  $rootScope.$on(stateChangeError, (_event, toState, toParams, fromState, fromParams, error) => {
    if (!error) {
      return;
    }
    const builder = error && error.status === 404 ? $ExceptionlessClient.createNotFound(error.config.url) : $ExceptionlessClient.createUnhandledException(error, stateChangeError);
    void builder.setSource(stateChangeError).setMessage(error?.statusText).setProperty("toState", toState).setProperty("toParams", toParams).setProperty("fromState", fromState).setProperty("fromParams", fromParams).submit();
  });
  $rootScope.$on("$destroy", () => {
    void $ExceptionlessClient.config.services.queue.process();
  });
}]);
//# sourceMappingURL=index.bundle.js.map
